]> git.proxmox.com Git - mirror_qemu.git/blob - configure
configure: add --enable-pypi and --disable-pypi
[mirror_qemu.git] / configure
1 #!/bin/sh
2 #
3 # qemu configure script (c) 2003 Fabrice Bellard
4 #
5
6 # Unset some variables known to interfere with behavior of common tools,
7 # just as autoconf does.
8 CLICOLOR_FORCE= GREP_OPTIONS=
9 unset CLICOLOR_FORCE GREP_OPTIONS
10
11 # Don't allow CCACHE, if present, to use cached results of compile tests!
12 export CCACHE_RECACHE=yes
13
14 # make source path absolute
15 source_path=$(cd "$(dirname -- "$0")"; pwd)
16
17 if test "$PWD" = "$source_path"
18 then
19 echo "Using './build' as the directory for build output"
20
21 MARKER=build/auto-created-by-configure
22
23 if test -e build
24 then
25 if test -f $MARKER
26 then
27 rm -rf build
28 else
29 echo "ERROR: ./build dir already exists and was not previously created by configure"
30 exit 1
31 fi
32 fi
33
34 if ! mkdir build || ! touch $MARKER
35 then
36 echo "ERROR: Could not create ./build directory. Check the permissions on"
37 echo "your source directory, or try doing an out-of-tree build."
38 exit 1
39 fi
40
41 cat > GNUmakefile <<'EOF'
42 # This file is auto-generated by configure to support in-source tree
43 # 'make' command invocation
44
45 ifeq ($(MAKECMDGOALS),)
46 recurse: all
47 endif
48
49 .NOTPARALLEL: %
50 %: force
51 @echo 'changing dir to build for $(MAKE) "$(MAKECMDGOALS)"...'
52 @$(MAKE) -C build -f Makefile $(MAKECMDGOALS)
53 @if test "$(MAKECMDGOALS)" = "distclean" && \
54 test -e build/auto-created-by-configure ; \
55 then \
56 rm -rf build GNUmakefile ; \
57 fi
58 force: ;
59 .PHONY: force
60 GNUmakefile: ;
61
62 EOF
63 cd build
64 exec "$source_path/configure" "$@"
65 fi
66
67 # Temporary directory used for files created while
68 # configure runs. Since it is in the build directory
69 # we can safely blow away any previous version of it
70 # (and we need not jump through hoops to try to delete
71 # it when configure exits.)
72 TMPDIR1="config-temp"
73 rm -rf "${TMPDIR1}"
74 if ! mkdir -p "${TMPDIR1}"; then
75 echo "ERROR: failed to create temporary directory"
76 exit 1
77 fi
78
79 TMPB="qemu-conf"
80 TMPC="${TMPDIR1}/${TMPB}.c"
81 TMPO="${TMPDIR1}/${TMPB}.o"
82 TMPM="${TMPDIR1}/${TMPB}.m"
83 TMPE="${TMPDIR1}/${TMPB}.exe"
84
85 rm -f config.log
86
87 # Print a helpful header at the top of config.log
88 echo "# QEMU configure log $(date)" >> config.log
89 printf "# Configured with:" >> config.log
90 # repeat the invocation to log and stdout for CI
91 invoke=$(printf " '%s'" "$0" "$@")
92 test -n "$GITLAB_CI" && echo "configuring with: $invoke"
93 { echo "$invoke"; echo; echo "#"; } >> config.log
94
95 quote_sh() {
96 printf "%s" "$1" | sed "s,','\\\\'',g; s,.*,'&',"
97 }
98
99 print_error() {
100 (echo
101 echo "ERROR: $1"
102 while test -n "$2"; do
103 echo " $2"
104 shift
105 done
106 echo) >&2
107 }
108
109 error_exit() {
110 print_error "$@"
111 exit 1
112 }
113
114 do_compiler() {
115 # Run the compiler, capturing its output to the log. First argument
116 # is compiler binary to execute.
117 compiler="$1"
118 shift
119 if test -n "$BASH_VERSION"; then eval '
120 echo >>config.log "
121 funcs: ${FUNCNAME[*]}
122 lines: ${BASH_LINENO[*]}"
123 '; fi
124 echo $compiler "$@" >> config.log
125 $compiler "$@" >> config.log 2>&1 || return $?
126 }
127
128 do_compiler_werror() {
129 # Run the compiler, capturing its output to the log. First argument
130 # is compiler binary to execute.
131 compiler="$1"
132 shift
133 if test -n "$BASH_VERSION"; then eval '
134 echo >>config.log "
135 funcs: ${FUNCNAME[*]}
136 lines: ${BASH_LINENO[*]}"
137 '; fi
138 echo $compiler "$@" >> config.log
139 $compiler "$@" >> config.log 2>&1 || return $?
140 # Test passed. If this is an --enable-werror build, rerun
141 # the test with -Werror and bail out if it fails. This
142 # makes warning-generating-errors in configure test code
143 # obvious to developers.
144 if test "$werror" != "yes"; then
145 return 0
146 fi
147 # Don't bother rerunning the compile if we were already using -Werror
148 case "$*" in
149 *-Werror*)
150 return 0
151 ;;
152 esac
153 echo $compiler -Werror "$@" >> config.log
154 $compiler -Werror "$@" >> config.log 2>&1 && return $?
155 error_exit "configure test passed without -Werror but failed with -Werror." \
156 "This is probably a bug in the configure script. The failing command" \
157 "will be at the bottom of config.log." \
158 "You can run configure with --disable-werror to bypass this check."
159 }
160
161 do_cc() {
162 do_compiler_werror "$cc" $CPU_CFLAGS "$@"
163 }
164
165 do_objc() {
166 do_compiler_werror "$objcc" $CPU_CFLAGS "$@"
167 }
168
169 # Append $2 to the variable named $1, with space separation
170 add_to() {
171 eval $1=\${$1:+\"\$$1 \"}\$2
172 }
173
174 compile_object() {
175 local_cflags="$1"
176 do_cc $CFLAGS $EXTRA_CFLAGS $CONFIGURE_CFLAGS $QEMU_CFLAGS $local_cflags -c -o $TMPO $TMPC
177 }
178
179 compile_prog() {
180 local_cflags="$1"
181 local_ldflags="$2"
182 do_cc $CFLAGS $EXTRA_CFLAGS $CONFIGURE_CFLAGS $QEMU_CFLAGS $local_cflags -o $TMPE $TMPC \
183 $LDFLAGS $EXTRA_LDFLAGS $CONFIGURE_LDFLAGS $QEMU_LDFLAGS $local_ldflags
184 }
185
186 # symbolically link $1 to $2. Portable version of "ln -sf".
187 symlink() {
188 rm -rf "$2"
189 mkdir -p "$(dirname "$2")"
190 ln -s "$1" "$2"
191 }
192
193 # check whether a command is available to this shell (may be either an
194 # executable or a builtin)
195 has() {
196 type "$1" >/dev/null 2>&1
197 }
198
199 version_ge () {
200 local_ver1=$(expr "$1" : '\([0-9.]*\)' | tr . ' ')
201 local_ver2=$(echo "$2" | tr . ' ')
202 while true; do
203 set x $local_ver1
204 local_first=${2-0}
205 # 'shift 2' if $2 is set, or 'shift' if $2 is not set
206 shift ${2:+2}
207 local_ver1=$*
208 set x $local_ver2
209 # the second argument finished, the first must be greater or equal
210 test $# = 1 && return 0
211 test $local_first -lt $2 && return 1
212 test $local_first -gt $2 && return 0
213 shift ${2:+2}
214 local_ver2=$*
215 done
216 }
217
218 if printf %s\\n "$source_path" "$PWD" | grep -q "[[:space:]:]";
219 then
220 error_exit "main directory cannot contain spaces nor colons"
221 fi
222
223 # default parameters
224 cpu=""
225 static="no"
226 cross_compile="no"
227 cross_prefix=""
228 host_cc="cc"
229 stack_protector=""
230 safe_stack=""
231 use_containers="yes"
232 gdb_bin=$(command -v "gdb-multiarch" || command -v "gdb")
233 gdb_arches=""
234 glib_has_gslice="no"
235
236 if test -e "$source_path/.git"
237 then
238 git_submodules_action="update"
239 else
240 git_submodules_action="ignore"
241 fi
242
243 git_submodules="ui/keycodemapdb"
244 git="git"
245
246 # Don't accept a target_list environment variable.
247 unset target_list
248 unset target_list_exclude
249
250 # Default value for a variable defining feature "foo".
251 # * foo="no" feature will only be used if --enable-foo arg is given
252 # * foo="" feature will be searched for, and if found, will be used
253 # unless --disable-foo is given
254 # * foo="yes" this value will only be set by --enable-foo flag.
255 # feature will searched for,
256 # if not found, configure exits with error
257 #
258 # Always add --enable-foo and --disable-foo command line args.
259 # Distributions want to ensure that several features are compiled in, and it
260 # is impossible without a --enable-foo that exits if a feature is not found.
261
262 default_feature=""
263 # parse CC options second
264 for opt do
265 optarg=$(expr "x$opt" : 'x[^=]*=\(.*\)')
266 case "$opt" in
267 --without-default-features)
268 default_feature="no"
269 ;;
270 esac
271 done
272
273 EXTRA_CFLAGS=""
274 EXTRA_CXXFLAGS=""
275 EXTRA_OBJCFLAGS=""
276 EXTRA_LDFLAGS=""
277
278 debug_tcg="no"
279 sanitizers="no"
280 tsan="no"
281 fortify_source="yes"
282 docs="auto"
283 EXESUF=""
284 modules="no"
285 prefix="/usr/local"
286 qemu_suffix="qemu"
287 softmmu="yes"
288 linux_user=""
289 bsd_user=""
290 pie=""
291 coroutine=""
292 plugins="$default_feature"
293 ninja=""
294 bindir="bin"
295 skip_meson=no
296 vfio_user_server="disabled"
297
298 # The following Meson options are handled manually (still they
299 # are included in the automatically generated help message)
300
301 # 1. Track which submodules are needed
302 fdt="auto"
303
304 # 2. Automatically enable/disable other options
305 tcg="auto"
306 cfi="false"
307
308 # parse CC options second
309 for opt do
310 optarg=$(expr "x$opt" : 'x[^=]*=\(.*\)')
311 case "$opt" in
312 --cross-prefix=*) cross_prefix="$optarg"
313 cross_compile="yes"
314 ;;
315 --cc=*) CC="$optarg"
316 ;;
317 --cxx=*) CXX="$optarg"
318 ;;
319 --objcc=*) objcc="$optarg"
320 ;;
321 --cpu=*) cpu="$optarg"
322 ;;
323 --extra-cflags=*)
324 EXTRA_CFLAGS="$EXTRA_CFLAGS $optarg"
325 EXTRA_CXXFLAGS="$EXTRA_CXXFLAGS $optarg"
326 EXTRA_OBJCFLAGS="$EXTRA_OBJCFLAGS $optarg"
327 ;;
328 --extra-cxxflags=*) EXTRA_CXXFLAGS="$EXTRA_CXXFLAGS $optarg"
329 ;;
330 --extra-objcflags=*) EXTRA_OBJCFLAGS="$EXTRA_OBJCFLAGS $optarg"
331 ;;
332 --extra-ldflags=*) EXTRA_LDFLAGS="$EXTRA_LDFLAGS $optarg"
333 ;;
334 --cross-cc-*[!a-zA-Z0-9_-]*=*) error_exit "Passed bad --cross-cc-FOO option"
335 ;;
336 --cross-cc-cflags-*) cc_arch=${opt#--cross-cc-cflags-}; cc_arch=${cc_arch%%=*}
337 eval "cross_cc_cflags_${cc_arch}=\$optarg"
338 ;;
339 --cross-cc-*) cc_arch=${opt#--cross-cc-}; cc_arch=${cc_arch%%=*}
340 eval "cross_cc_${cc_arch}=\$optarg"
341 ;;
342 --cross-prefix-*[!a-zA-Z0-9_-]*=*) error_exit "Passed bad --cross-prefix-FOO option"
343 ;;
344 --cross-prefix-*) cc_arch=${opt#--cross-prefix-}; cc_arch=${cc_arch%%=*}
345 eval "cross_prefix_${cc_arch}=\$optarg"
346 ;;
347 esac
348 done
349
350 # Preferred compiler:
351 # ${CC} (if set)
352 # ${cross_prefix}gcc (if cross-prefix specified)
353 # system compiler
354 if test -z "${CC}${cross_prefix}"; then
355 cc="$host_cc"
356 else
357 cc="${CC-${cross_prefix}gcc}"
358 fi
359
360 if test -z "${CXX}${cross_prefix}"; then
361 cxx="c++"
362 else
363 cxx="${CXX-${cross_prefix}g++}"
364 fi
365
366 # Preferred ObjC compiler:
367 # $objcc (if set, i.e. via --objcc option)
368 # ${cross_prefix}clang (if cross-prefix specified)
369 # clang (if available)
370 # $cc
371 if test -z "${objcc}${cross_prefix}"; then
372 if has clang; then
373 objcc=clang
374 else
375 objcc="$cc"
376 fi
377 else
378 objcc="${objcc-${cross_prefix}clang}"
379 fi
380
381 ar="${AR-${cross_prefix}ar}"
382 as="${AS-${cross_prefix}as}"
383 ccas="${CCAS-$cc}"
384 objcopy="${OBJCOPY-${cross_prefix}objcopy}"
385 ld="${LD-${cross_prefix}ld}"
386 ranlib="${RANLIB-${cross_prefix}ranlib}"
387 nm="${NM-${cross_prefix}nm}"
388 smbd="$SMBD"
389 strip="${STRIP-${cross_prefix}strip}"
390 widl="${WIDL-${cross_prefix}widl}"
391 windres="${WINDRES-${cross_prefix}windres}"
392 windmc="${WINDMC-${cross_prefix}windmc}"
393 pkg_config_exe="${PKG_CONFIG-${cross_prefix}pkg-config}"
394 query_pkg_config() {
395 "${pkg_config_exe}" ${QEMU_PKG_CONFIG_FLAGS} "$@"
396 }
397 pkg_config=query_pkg_config
398 sdl2_config="${SDL2_CONFIG-${cross_prefix}sdl2-config}"
399
400 # default flags for all hosts
401 # We use -fwrapv to tell the compiler that we require a C dialect where
402 # left shift of signed integers is well defined and has the expected
403 # 2s-complement style results. (Both clang and gcc agree that it
404 # provides these semantics.)
405 QEMU_CFLAGS="-fno-strict-aliasing -fno-common -fwrapv"
406 QEMU_CFLAGS="-D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE $QEMU_CFLAGS"
407
408 QEMU_LDFLAGS=
409
410 # Flags that are needed during configure but later taken care of by Meson
411 CONFIGURE_CFLAGS="-std=gnu11 -Wall"
412 CONFIGURE_LDFLAGS=
413
414
415 check_define() {
416 cat > $TMPC <<EOF
417 #if !defined($1)
418 #error $1 not defined
419 #endif
420 int main(void) { return 0; }
421 EOF
422 compile_object
423 }
424
425 check_include() {
426 cat > $TMPC <<EOF
427 #include <$1>
428 int main(void) { return 0; }
429 EOF
430 compile_object
431 }
432
433 write_c_skeleton() {
434 cat > $TMPC <<EOF
435 int main(void) { return 0; }
436 EOF
437 }
438
439 if check_define __linux__ ; then
440 targetos=linux
441 elif check_define _WIN32 ; then
442 targetos=windows
443 elif check_define __OpenBSD__ ; then
444 targetos=openbsd
445 elif check_define __sun__ ; then
446 targetos=sunos
447 elif check_define __HAIKU__ ; then
448 targetos=haiku
449 elif check_define __FreeBSD__ ; then
450 targetos=freebsd
451 elif check_define __FreeBSD_kernel__ && check_define __GLIBC__; then
452 targetos=gnu/kfreebsd
453 elif check_define __DragonFly__ ; then
454 targetos=dragonfly
455 elif check_define __NetBSD__; then
456 targetos=netbsd
457 elif check_define __APPLE__; then
458 targetos=darwin
459 else
460 # This is a fatal error, but don't report it yet, because we
461 # might be going to just print the --help text, or it might
462 # be the result of a missing compiler.
463 targetos=bogus
464 fi
465
466 # OS specific
467
468 mingw32="no"
469 bsd="no"
470 linux="no"
471 solaris="no"
472 case $targetos in
473 windows)
474 mingw32="yes"
475 plugins="no"
476 pie="no"
477 ;;
478 gnu/kfreebsd)
479 bsd="yes"
480 ;;
481 freebsd)
482 bsd="yes"
483 make="${MAKE-gmake}"
484 # needed for kinfo_getvmmap(3) in libutil.h
485 ;;
486 dragonfly)
487 bsd="yes"
488 make="${MAKE-gmake}"
489 ;;
490 netbsd)
491 bsd="yes"
492 make="${MAKE-gmake}"
493 ;;
494 openbsd)
495 bsd="yes"
496 make="${MAKE-gmake}"
497 ;;
498 darwin)
499 bsd="yes"
500 darwin="yes"
501 # Disable attempts to use ObjectiveC features in os/object.h since they
502 # won't work when we're compiling with gcc as a C compiler.
503 QEMU_CFLAGS="-DOS_OBJECT_USE_OBJC=0 $QEMU_CFLAGS"
504 ;;
505 sunos)
506 solaris="yes"
507 make="${MAKE-gmake}"
508 # needed for CMSG_ macros in sys/socket.h
509 QEMU_CFLAGS="-D_XOPEN_SOURCE=600 $QEMU_CFLAGS"
510 # needed for TIOCWIN* defines in termios.h
511 QEMU_CFLAGS="-D__EXTENSIONS__ $QEMU_CFLAGS"
512 ;;
513 haiku)
514 pie="no"
515 QEMU_CFLAGS="-DB_USE_POSITIVE_POSIX_ERRORS -D_BSD_SOURCE -fPIC $QEMU_CFLAGS"
516 ;;
517 linux)
518 linux="yes"
519 ;;
520 esac
521
522 if test ! -z "$cpu" ; then
523 # command line argument
524 :
525 elif check_define __i386__ ; then
526 cpu="i386"
527 elif check_define __x86_64__ ; then
528 if check_define __ILP32__ ; then
529 cpu="x32"
530 else
531 cpu="x86_64"
532 fi
533 elif check_define __sparc__ ; then
534 if check_define __arch64__ ; then
535 cpu="sparc64"
536 else
537 cpu="sparc"
538 fi
539 elif check_define _ARCH_PPC ; then
540 if check_define _ARCH_PPC64 ; then
541 if check_define _LITTLE_ENDIAN ; then
542 cpu="ppc64le"
543 else
544 cpu="ppc64"
545 fi
546 else
547 cpu="ppc"
548 fi
549 elif check_define __mips__ ; then
550 cpu="mips"
551 elif check_define __s390__ ; then
552 if check_define __s390x__ ; then
553 cpu="s390x"
554 else
555 cpu="s390"
556 fi
557 elif check_define __riscv ; then
558 cpu="riscv"
559 elif check_define __arm__ ; then
560 cpu="arm"
561 elif check_define __aarch64__ ; then
562 cpu="aarch64"
563 elif check_define __loongarch64 ; then
564 cpu="loongarch64"
565 else
566 # Using uname is really broken, but it is just a fallback for architectures
567 # that are going to use TCI anyway
568 cpu=$(uname -m)
569 echo "WARNING: unrecognized host CPU, proceeding with 'uname -m' output '$cpu'"
570 fi
571
572 # Normalise host CPU name and set multilib cflags. The canonicalization
573 # isn't really necessary, because the architectures that we check for
574 # should not hit the 'uname -m' case, but better safe than sorry.
575 # Note that this case should only have supported host CPUs, not guests.
576 case "$cpu" in
577 armv*b|armv*l|arm)
578 cpu="arm" ;;
579
580 i386|i486|i586|i686)
581 cpu="i386"
582 CPU_CFLAGS="-m32" ;;
583 x32)
584 cpu="x86_64"
585 CPU_CFLAGS="-mx32" ;;
586 x86_64|amd64)
587 cpu="x86_64"
588 # ??? Only extremely old AMD cpus do not have cmpxchg16b.
589 # If we truly care, we should simply detect this case at
590 # runtime and generate the fallback to serial emulation.
591 CPU_CFLAGS="-m64 -mcx16" ;;
592
593 mips*)
594 cpu="mips" ;;
595
596 ppc)
597 CPU_CFLAGS="-m32" ;;
598 ppc64)
599 CPU_CFLAGS="-m64 -mbig-endian" ;;
600 ppc64le)
601 cpu="ppc64"
602 CPU_CFLAGS="-m64 -mlittle-endian" ;;
603
604 s390)
605 CPU_CFLAGS="-m31" ;;
606 s390x)
607 CPU_CFLAGS="-m64" ;;
608
609 sparc|sun4[cdmuv])
610 cpu="sparc"
611 CPU_CFLAGS="-m32 -mv8plus -mcpu=ultrasparc" ;;
612 sparc64)
613 CPU_CFLAGS="-m64 -mcpu=ultrasparc" ;;
614 esac
615
616 : ${make=${MAKE-make}}
617
618
619 check_py_version() {
620 # We require python >= 3.6.
621 # NB: a True python conditional creates a non-zero return code (Failure)
622 "$1" -c 'import sys; sys.exit(sys.version_info < (3,6))'
623 }
624
625 python=
626 pypi="enabled"
627 first_python=
628 if test -z "${PYTHON}"; then
629 # A bare 'python' is traditionally python 2.x, but some distros
630 # have it as python 3.x, so check in both places.
631 for binary in python3 python python3.11 python3.10 python3.9 python3.8 python3.7 python3.6; do
632 if has "$binary"; then
633 python=$(command -v "$binary")
634 if check_py_version "$python"; then
635 # This one is good.
636 first_python=
637 break
638 else
639 first_python=$python
640 fi
641 fi
642 done
643 else
644 # Same as above, but only check the environment variable.
645 has "${PYTHON}" || error_exit "The PYTHON environment variable does not point to an executable"
646 python=$(command -v "$PYTHON")
647 if check_py_version "$python"; then
648 # This one is good.
649 first_python=
650 else
651 first_python=$first_python
652 fi
653 fi
654
655 # Check for ancillary tools used in testing
656 genisoimage=
657 for binary in genisoimage mkisofs
658 do
659 if has $binary
660 then
661 genisoimage=$(command -v "$binary")
662 break
663 fi
664 done
665
666 if test "$mingw32" = "yes" ; then
667 EXESUF=".exe"
668 # MinGW needs -mthreads for TLS and macro _MT.
669 CONFIGURE_CFLAGS="-mthreads $CONFIGURE_CFLAGS"
670 prefix="/qemu"
671 bindir=""
672 qemu_suffix=""
673 fi
674
675 werror=""
676
677 meson_option_build_array() {
678 printf '['
679 (if test "$targetos" = windows; then
680 IFS=\;
681 else
682 IFS=:
683 fi
684 for e in $1; do
685 printf '"""'
686 # backslash escape any '\' and '"' characters
687 printf "%s" "$e" | sed -e 's/\([\"]\)/\\\1/g'
688 printf '""",'
689 done)
690 printf ']\n'
691 }
692
693 . "$source_path/scripts/meson-buildoptions.sh"
694
695 meson_options=
696 meson_option_add() {
697 meson_options="$meson_options $(quote_sh "$1")"
698 }
699 meson_option_parse() {
700 meson_options="$meson_options $(_meson_option_parse "$@")"
701 if test $? -eq 1; then
702 echo "ERROR: unknown option $1"
703 echo "Try '$0 --help' for more information"
704 exit 1
705 fi
706 }
707
708 for opt do
709 optarg=$(expr "x$opt" : 'x[^=]*=\(.*\)')
710 case "$opt" in
711 --help|-h) show_help=yes
712 ;;
713 --version|-V) exec cat "$source_path/VERSION"
714 ;;
715 --prefix=*) prefix="$optarg"
716 ;;
717 --cross-prefix=*)
718 ;;
719 --cc=*)
720 ;;
721 --host-cc=*) host_cc="$optarg"
722 ;;
723 --cxx=*)
724 ;;
725 --objcc=*)
726 ;;
727 --make=*) make="$optarg"
728 ;;
729 --install=*)
730 ;;
731 --python=*) python="$optarg"
732 ;;
733 --skip-meson) skip_meson=yes
734 ;;
735 --ninja=*) ninja="$optarg"
736 ;;
737 --smbd=*) smbd="$optarg"
738 ;;
739 --extra-cflags=*)
740 ;;
741 --extra-cxxflags=*)
742 ;;
743 --extra-objcflags=*)
744 ;;
745 --extra-ldflags=*)
746 ;;
747 --cross-cc-*)
748 ;;
749 --cross-prefix-*)
750 ;;
751 --enable-debug-info) meson_option_add -Ddebug=true
752 ;;
753 --disable-debug-info) meson_option_add -Ddebug=false
754 ;;
755 --enable-docs) docs=enabled
756 ;;
757 --disable-docs) docs=disabled
758 ;;
759 --enable-modules)
760 modules="yes"
761 ;;
762 --disable-modules)
763 modules="no"
764 ;;
765 --cpu=*)
766 ;;
767 --target-list=*) target_list="$optarg"
768 if test "$target_list_exclude"; then
769 error_exit "Can't mix --target-list with --target-list-exclude"
770 fi
771 ;;
772 --target-list-exclude=*) target_list_exclude="$optarg"
773 if test "$target_list"; then
774 error_exit "Can't mix --target-list-exclude with --target-list"
775 fi
776 ;;
777 --with-default-devices) meson_option_add -Ddefault_devices=true
778 ;;
779 --without-default-devices) meson_option_add -Ddefault_devices=false
780 ;;
781 --with-devices-*[!a-zA-Z0-9_-]*=*) error_exit "Passed bad --with-devices-FOO option"
782 ;;
783 --with-devices-*) device_arch=${opt#--with-devices-};
784 device_arch=${device_arch%%=*}
785 cf=$source_path/configs/devices/$device_arch-softmmu/$optarg.mak
786 if test -f "$cf"; then
787 device_archs="$device_archs $device_arch"
788 eval "devices_${device_arch}=\$optarg"
789 else
790 error_exit "File $cf does not exist"
791 fi
792 ;;
793 --without-default-features) # processed above
794 ;;
795 --static)
796 static="yes"
797 QEMU_PKG_CONFIG_FLAGS="--static $QEMU_PKG_CONFIG_FLAGS"
798 ;;
799 --bindir=*) bindir="$optarg"
800 ;;
801 --with-suffix=*) qemu_suffix="$optarg"
802 ;;
803 --host=*|--build=*|\
804 --disable-dependency-tracking|\
805 --sbindir=*|--sharedstatedir=*|\
806 --oldincludedir=*|--datarootdir=*|--infodir=*|\
807 --htmldir=*|--dvidir=*|--pdfdir=*|--psdir=*)
808 # These switches are silently ignored, for compatibility with
809 # autoconf-generated configure scripts. This allows QEMU's
810 # configure to be used by RPM and similar macros that set
811 # lots of directory switches by default.
812 ;;
813 --enable-debug-tcg) debug_tcg="yes"
814 ;;
815 --disable-debug-tcg) debug_tcg="no"
816 ;;
817 --enable-debug)
818 # Enable debugging options that aren't excessively noisy
819 debug_tcg="yes"
820 meson_option_parse --enable-debug-graph-lock ""
821 meson_option_parse --enable-debug-mutex ""
822 meson_option_add -Doptimization=0
823 fortify_source="no"
824 ;;
825 --enable-sanitizers) sanitizers="yes"
826 ;;
827 --disable-sanitizers) sanitizers="no"
828 ;;
829 --enable-tsan) tsan="yes"
830 ;;
831 --disable-tsan) tsan="no"
832 ;;
833 --disable-tcg) tcg="disabled"
834 plugins="no"
835 ;;
836 --enable-tcg) tcg="enabled"
837 ;;
838 --disable-system) softmmu="no"
839 ;;
840 --enable-system) softmmu="yes"
841 ;;
842 --disable-user)
843 linux_user="no" ;
844 bsd_user="no" ;
845 ;;
846 --enable-user) ;;
847 --disable-linux-user) linux_user="no"
848 ;;
849 --enable-linux-user) linux_user="yes"
850 ;;
851 --disable-bsd-user) bsd_user="no"
852 ;;
853 --enable-bsd-user) bsd_user="yes"
854 ;;
855 --enable-pie) pie="yes"
856 ;;
857 --disable-pie) pie="no"
858 ;;
859 --enable-werror) werror="yes"
860 ;;
861 --disable-werror) werror="no"
862 ;;
863 --enable-stack-protector) stack_protector="yes"
864 ;;
865 --disable-stack-protector) stack_protector="no"
866 ;;
867 --enable-safe-stack) safe_stack="yes"
868 ;;
869 --disable-safe-stack) safe_stack="no"
870 ;;
871 --enable-cfi)
872 cfi="true";
873 meson_option_add -Db_lto=true
874 ;;
875 --disable-cfi) cfi="false"
876 ;;
877 --disable-fdt) fdt="disabled"
878 ;;
879 --enable-fdt) fdt="enabled"
880 ;;
881 --enable-fdt=git) fdt="internal"
882 ;;
883 --enable-fdt=*) fdt="$optarg"
884 ;;
885 --with-coroutine=*) coroutine="$optarg"
886 ;;
887 --with-git=*) git="$optarg"
888 ;;
889 --with-git-submodules=*)
890 git_submodules_action="$optarg"
891 ;;
892 --disable-pypi) pypi="disabled"
893 ;;
894 --enable-pypi) pypi="enabled"
895 ;;
896 --enable-plugins) if test "$mingw32" = "yes"; then
897 error_exit "TCG plugins not currently supported on Windows platforms"
898 else
899 plugins="yes"
900 fi
901 ;;
902 --disable-plugins) plugins="no"
903 ;;
904 --enable-containers) use_containers="yes"
905 ;;
906 --disable-containers) use_containers="no"
907 ;;
908 --gdb=*) gdb_bin="$optarg"
909 ;;
910 --enable-vfio-user-server) vfio_user_server="enabled"
911 ;;
912 --disable-vfio-user-server) vfio_user_server="disabled"
913 ;;
914 # everything else has the same name in configure and meson
915 --*) meson_option_parse "$opt" "$optarg"
916 ;;
917 esac
918 done
919
920 # test for any invalid configuration combinations
921 if test "$plugins" = "yes" -a "$tcg" = "disabled"; then
922 error_exit "Can't enable plugins on non-TCG builds"
923 fi
924
925 case $git_submodules_action in
926 update|validate)
927 if test ! -e "$source_path/.git"; then
928 echo "ERROR: cannot $git_submodules_action git submodules without .git"
929 exit 1
930 fi
931 ;;
932 ignore)
933 if ! test -f "$source_path/ui/keycodemapdb/README"
934 then
935 echo
936 echo "ERROR: missing GIT submodules"
937 echo
938 if test -e "$source_path/.git"; then
939 echo "--with-git-submodules=ignore specified but submodules were not"
940 echo "checked out. Please initialize and update submodules."
941 else
942 echo "This is not a GIT checkout but module content appears to"
943 echo "be missing. Do not use 'git archive' or GitHub download links"
944 echo "to acquire QEMU source archives. Non-GIT builds are only"
945 echo "supported with source archives linked from:"
946 echo
947 echo " https://www.qemu.org/download/#source"
948 echo
949 echo "Developers working with GIT can use scripts/archive-source.sh"
950 echo "if they need to create valid source archives."
951 fi
952 echo
953 exit 1
954 fi
955 ;;
956 *)
957 echo "ERROR: invalid --with-git-submodules= value '$git_submodules_action'"
958 exit 1
959 ;;
960 esac
961
962 default_target_list=""
963 mak_wilds=""
964
965 if [ "$linux_user" != no ]; then
966 if [ "$targetos" = linux ] && [ -d "$source_path/linux-user/include/host/$cpu" ]; then
967 linux_user=yes
968 elif [ "$linux_user" = yes ]; then
969 error_exit "linux-user not supported on this architecture"
970 fi
971 fi
972 if [ "$bsd_user" != no ]; then
973 if [ "$bsd_user" = "" ]; then
974 test $targetos = freebsd && bsd_user=yes
975 fi
976 if [ "$bsd_user" = yes ] && ! [ -d "$source_path/bsd-user/$targetos" ]; then
977 error_exit "bsd-user not supported on this host OS"
978 fi
979 fi
980 if [ "$softmmu" = "yes" ]; then
981 mak_wilds="${mak_wilds} $source_path/configs/targets/*-softmmu.mak"
982 fi
983 if [ "$linux_user" = "yes" ]; then
984 mak_wilds="${mak_wilds} $source_path/configs/targets/*-linux-user.mak"
985 fi
986 if [ "$bsd_user" = "yes" ]; then
987 mak_wilds="${mak_wilds} $source_path/configs/targets/*-bsd-user.mak"
988 fi
989
990 for config in $mak_wilds; do
991 target="$(basename "$config" .mak)"
992 if echo "$target_list_exclude" | grep -vq "$target"; then
993 default_target_list="${default_target_list} $target"
994 fi
995 done
996
997 if test x"$show_help" = x"yes" ; then
998 cat << EOF
999
1000 Usage: configure [options]
1001 Options: [defaults in brackets after descriptions]
1002
1003 Standard options:
1004 --help print this message
1005 --prefix=PREFIX install in PREFIX [$prefix]
1006 --target-list=LIST set target list (default: build all)
1007 $(echo Available targets: $default_target_list | \
1008 fold -s -w 53 | sed -e 's/^/ /')
1009 --target-list-exclude=LIST exclude a set of targets from the default target-list
1010
1011 Advanced options (experts only):
1012 --cross-prefix=PREFIX use PREFIX for compile tools, PREFIX can be blank [$cross_prefix]
1013 --cc=CC use C compiler CC [$cc]
1014 --host-cc=CC use C compiler CC [$host_cc] for code run at
1015 build time
1016 --cxx=CXX use C++ compiler CXX [$cxx]
1017 --objcc=OBJCC use Objective-C compiler OBJCC [$objcc]
1018 --extra-cflags=CFLAGS append extra C compiler flags CFLAGS
1019 --extra-cxxflags=CXXFLAGS append extra C++ compiler flags CXXFLAGS
1020 --extra-objcflags=OBJCFLAGS append extra Objective C compiler flags OBJCFLAGS
1021 --extra-ldflags=LDFLAGS append extra linker flags LDFLAGS
1022 --cross-cc-ARCH=CC use compiler when building ARCH guest test cases
1023 --cross-cc-cflags-ARCH= use compiler flags when building ARCH guest tests
1024 --cross-prefix-ARCH=PREFIX cross compiler prefix when building ARCH guest test cases
1025 --make=MAKE use specified make [$make]
1026 --python=PYTHON use specified python [$python]
1027 --ninja=NINJA use specified ninja [$ninja]
1028 --smbd=SMBD use specified smbd [$smbd]
1029 --with-git=GIT use specified git [$git]
1030 --with-git-submodules=update update git submodules (default if .git dir exists)
1031 --with-git-submodules=validate fail if git submodules are not up to date
1032 --with-git-submodules=ignore do not update or check git submodules (default if no .git dir)
1033 --static enable static build [$static]
1034 --bindir=PATH install binaries in PATH
1035 --with-suffix=SUFFIX suffix for QEMU data inside datadir/libdir/sysconfdir/docdir [$qemu_suffix]
1036 --without-default-features default all --enable-* options to "disabled"
1037 --without-default-devices do not include any device that is not needed to
1038 start the emulator (only use if you are including
1039 desired devices in configs/devices/)
1040 --with-devices-ARCH=NAME override default configs/devices
1041 --enable-debug enable common debug build options
1042 --enable-sanitizers enable default sanitizers
1043 --enable-tsan enable thread sanitizer
1044 --disable-werror disable compilation abort on warning
1045 --disable-stack-protector disable compiler-provided stack protection
1046 --cpu=CPU Build for host CPU [$cpu]
1047 --with-coroutine=BACKEND coroutine backend. Supported options:
1048 ucontext, sigaltstack, windows
1049 --enable-plugins
1050 enable plugins via shared library loading
1051 --disable-containers don't use containers for cross-building
1052 --gdb=GDB-path gdb to use for gdbstub tests [$gdb_bin]
1053 EOF
1054 meson_options_help
1055 cat << EOF
1056 system all system emulation targets
1057 user supported user emulation targets
1058 linux-user all linux usermode emulation targets
1059 bsd-user all BSD usermode emulation targets
1060 pie Position Independent Executables
1061 modules modules support (non-Windows)
1062 debug-tcg TCG debugging (default is disabled)
1063 debug-info debugging information
1064 safe-stack SafeStack Stack Smash Protection. Depends on
1065 clang/llvm and requires coroutine backend ucontext.
1066
1067 NOTE: The object files are built at the place where configure is launched
1068 EOF
1069 exit 0
1070 fi
1071
1072 # Remove old dependency files to make sure that they get properly regenerated
1073 rm -f ./*/config-devices.mak.d
1074
1075 if test -z "$python"
1076 then
1077 # If first_python is set, there was a binary somewhere even though
1078 # it was not suitable. Use it for the error message.
1079 if test -n "$first_python"; then
1080 error_exit "Cannot use '$first_python', Python >= 3.6 is required." \
1081 "Use --python=/path/to/python to specify a supported Python."
1082 else
1083 error_exit "Python not found. Use --python=/path/to/python"
1084 fi
1085 fi
1086
1087 if ! has "$make"
1088 then
1089 error_exit "GNU make ($make) not found"
1090 fi
1091
1092 if ! check_py_version "$python"; then
1093 error_exit "Cannot use '$python', Python >= 3.6 is required." \
1094 "Use --python=/path/to/python to specify a supported Python."
1095 fi
1096
1097 # Resolve PATH
1098 python="$(command -v "$python")"
1099
1100 # Create a Python virtual environment using our configured python.
1101 # The stdout of this script will be the location of a symlink that
1102 # points to the configured Python.
1103 # Entry point scripts for pip, meson, and sphinx are generated if those
1104 # packages are present.
1105
1106 # Defaults assumed for now:
1107 # - venv is cleared if it exists already;
1108 # - venv is allowed to use system packages;
1109 # - all setup can be performed offline;
1110 # - missing packages may be fetched from PyPI,
1111 # unless --disable-pypi is passed.
1112 # - pip is not installed into the venv when possible,
1113 # but ensurepip is called as a fallback when necessary.
1114
1115 echo "python determined to be '$python'"
1116 echo "python version: $($python --version)"
1117
1118 python="$($python -B "${source_path}/python/scripts/mkvenv.py" create pyvenv)"
1119 if test "$?" -ne 0 ; then
1120 error_exit "python venv creation failed"
1121 fi
1122
1123 # Suppress writing compiled files
1124 python="$python -B"
1125 mkvenv="$python ${source_path}/python/scripts/mkvenv.py"
1126
1127 mkvenv_flags=""
1128 if test "$pypi" = "enabled" ; then
1129 mkvenv_flags="--online"
1130 fi
1131
1132 if ! $mkvenv ensure \
1133 $mkvenv_flags \
1134 --dir "${source_path}/python/wheels" \
1135 --diagnose "meson" \
1136 "meson>=0.61.5" ;
1137 then
1138 exit 1
1139 fi
1140
1141 # At this point, we expect Meson to be installed and available.
1142 # We expect mkvenv or pip to have created pyvenv/bin/meson for us.
1143 # We ignore PATH completely here: we want to use the venv's Meson
1144 # *exclusively*.
1145
1146 meson="$(cd pyvenv/bin; pwd)/meson"
1147
1148 # Conditionally ensure Sphinx is installed.
1149
1150 mkvenv_flags=""
1151 if test "$pypi" = "enabled" -a "$docs" = "enabled" ; then
1152 mkvenv_flags="--online"
1153 fi
1154
1155 if test "$docs" != "disabled" ; then
1156 if ! $mkvenv ensure \
1157 $mkvenv_flags \
1158 --diagnose "sphinx-build" \
1159 "sphinx>=1.6.0" "sphinx-rtd-theme>=0.5.0";
1160 then
1161 if test "$docs" = "enabled" ; then
1162 exit 1
1163 fi
1164 echo "Sphinx not found/usable, disabling docs."
1165 docs=disabled
1166 else
1167 docs=enabled
1168 fi
1169 fi
1170
1171 # Probe for ninja
1172
1173 if test -z "$ninja"; then
1174 for c in ninja ninja-build samu; do
1175 if has $c; then
1176 ninja=$(command -v "$c")
1177 break
1178 fi
1179 done
1180 if test -z "$ninja"; then
1181 error_exit "Cannot find Ninja"
1182 fi
1183 fi
1184
1185 # Check that the C compiler works. Doing this here before testing
1186 # the host CPU ensures that we had a valid CC to autodetect the
1187 # $cpu var (and we should bail right here if that's not the case).
1188 # It also allows the help message to be printed without a CC.
1189 write_c_skeleton;
1190 if compile_object ; then
1191 : C compiler works ok
1192 else
1193 error_exit "\"$cc\" either does not exist or does not work"
1194 fi
1195 if ! compile_prog ; then
1196 error_exit "\"$cc\" cannot build an executable (is your linker broken?)"
1197 fi
1198
1199 # Consult white-list to determine whether to enable werror
1200 # by default. Only enable by default for git builds
1201 if test -z "$werror" ; then
1202 if test "$git_submodules_action" != "ignore" && \
1203 { test "$linux" = "yes" || test "$mingw32" = "yes"; }; then
1204 werror="yes"
1205 else
1206 werror="no"
1207 fi
1208 fi
1209
1210 if test "$targetos" = "bogus"; then
1211 # Now that we know that we're not printing the help and that
1212 # the compiler works (so the results of the check_defines we used
1213 # to identify the OS are reliable), if we didn't recognize the
1214 # host OS we should stop now.
1215 error_exit "Unrecognized host OS (uname -s reports '$(uname -s)')"
1216 fi
1217
1218 # Check whether the compiler matches our minimum requirements:
1219 cat > $TMPC << EOF
1220 #if defined(__clang_major__) && defined(__clang_minor__)
1221 # ifdef __apple_build_version__
1222 # if __clang_major__ < 12 || (__clang_major__ == 12 && __clang_minor__ < 0)
1223 # error You need at least XCode Clang v12.0 to compile QEMU
1224 # endif
1225 # else
1226 # if __clang_major__ < 10 || (__clang_major__ == 10 && __clang_minor__ < 0)
1227 # error You need at least Clang v10.0 to compile QEMU
1228 # endif
1229 # endif
1230 #elif defined(__GNUC__) && defined(__GNUC_MINOR__)
1231 # if __GNUC__ < 7 || (__GNUC__ == 7 && __GNUC_MINOR__ < 4)
1232 # error You need at least GCC v7.4.0 to compile QEMU
1233 # endif
1234 #else
1235 # error You either need GCC or Clang to compiler QEMU
1236 #endif
1237 int main (void) { return 0; }
1238 EOF
1239 if ! compile_prog "" "" ; then
1240 error_exit "You need at least GCC v7.4 or Clang v10.0 (or XCode Clang v12.0)"
1241 fi
1242
1243 # Accumulate -Wfoo and -Wno-bar separately.
1244 # We will list all of the enable flags first, and the disable flags second.
1245 # Note that we do not add -Werror, because that would enable it for all
1246 # configure tests. If a configure test failed due to -Werror this would
1247 # just silently disable some features, so it's too error prone.
1248
1249 warn_flags=
1250 add_to warn_flags -Wundef
1251 add_to warn_flags -Wwrite-strings
1252 add_to warn_flags -Wmissing-prototypes
1253 add_to warn_flags -Wstrict-prototypes
1254 add_to warn_flags -Wredundant-decls
1255 add_to warn_flags -Wold-style-declaration
1256 add_to warn_flags -Wold-style-definition
1257 add_to warn_flags -Wtype-limits
1258 add_to warn_flags -Wformat-security
1259 add_to warn_flags -Wformat-y2k
1260 add_to warn_flags -Winit-self
1261 add_to warn_flags -Wignored-qualifiers
1262 add_to warn_flags -Wempty-body
1263 add_to warn_flags -Wnested-externs
1264 add_to warn_flags -Wendif-labels
1265 add_to warn_flags -Wexpansion-to-defined
1266 add_to warn_flags -Wimplicit-fallthrough=2
1267 add_to warn_flags -Wmissing-format-attribute
1268
1269 if test "$targetos" != "darwin"; then
1270 add_to warn_flags -Wthread-safety
1271 fi
1272
1273 nowarn_flags=
1274 add_to nowarn_flags -Wno-initializer-overrides
1275 add_to nowarn_flags -Wno-missing-include-dirs
1276 add_to nowarn_flags -Wno-shift-negative-value
1277 add_to nowarn_flags -Wno-string-plus-int
1278 add_to nowarn_flags -Wno-typedef-redefinition
1279 add_to nowarn_flags -Wno-tautological-type-limit-compare
1280 add_to nowarn_flags -Wno-psabi
1281 add_to nowarn_flags -Wno-gnu-variable-sized-type-not-at-end
1282
1283 gcc_flags="$warn_flags $nowarn_flags"
1284
1285 cc_has_warning_flag() {
1286 write_c_skeleton;
1287
1288 # Use the positive sense of the flag when testing for -Wno-wombat
1289 # support (gcc will happily accept the -Wno- form of unknown
1290 # warning options).
1291 optflag="$(echo $1 | sed -e 's/^-Wno-/-W/')"
1292 compile_prog "-Werror $optflag" ""
1293 }
1294
1295 objcc_has_warning_flag() {
1296 cat > $TMPM <<EOF
1297 int main(void) { return 0; }
1298 EOF
1299
1300 # Use the positive sense of the flag when testing for -Wno-wombat
1301 # support (gcc will happily accept the -Wno- form of unknown
1302 # warning options).
1303 optflag="$(echo $1 | sed -e 's/^-Wno-/-W/')"
1304 do_objc -Werror $optflag \
1305 $OBJCFLAGS $EXTRA_OBJCFLAGS $CONFIGURE_OBJCFLAGS $QEMU_OBJCFLAGS \
1306 -o $TMPE $TMPM $QEMU_LDFLAGS
1307 }
1308
1309 for flag in $gcc_flags; do
1310 if cc_has_warning_flag $flag ; then
1311 QEMU_CFLAGS="$QEMU_CFLAGS $flag"
1312 fi
1313 if objcc_has_warning_flag $flag ; then
1314 QEMU_OBJCFLAGS="$QEMU_OBJCFLAGS $flag"
1315 fi
1316 done
1317
1318 if test "$stack_protector" != "no"; then
1319 cat > $TMPC << EOF
1320 int main(int argc, char *argv[])
1321 {
1322 char arr[64], *p = arr, *c = argv[argc - 1];
1323 while (*c) {
1324 *p++ = *c++;
1325 }
1326 return 0;
1327 }
1328 EOF
1329 gcc_flags="-fstack-protector-strong -fstack-protector-all"
1330 sp_on=0
1331 for flag in $gcc_flags; do
1332 # We need to check both a compile and a link, since some compiler
1333 # setups fail only on a .c->.o compile and some only at link time
1334 if compile_object "-Werror $flag" &&
1335 compile_prog "-Werror $flag" ""; then
1336 QEMU_CFLAGS="$QEMU_CFLAGS $flag"
1337 QEMU_LDFLAGS="$QEMU_LDFLAGS $flag"
1338 sp_on=1
1339 break
1340 fi
1341 done
1342 if test "$stack_protector" = yes; then
1343 if test $sp_on = 0; then
1344 error_exit "Stack protector not supported"
1345 fi
1346 fi
1347 fi
1348
1349 # Our module code doesn't support Windows
1350 if test "$modules" = "yes" && test "$mingw32" = "yes" ; then
1351 error_exit "Modules are not available for Windows"
1352 fi
1353
1354 # Static linking is not possible with plugins, modules or PIE
1355 if test "$static" = "yes" ; then
1356 if test "$modules" = "yes" ; then
1357 error_exit "static and modules are mutually incompatible"
1358 fi
1359 if test "$plugins" = "yes"; then
1360 error_exit "static and plugins are mutually incompatible"
1361 else
1362 plugins="no"
1363 fi
1364 fi
1365 test "$plugins" = "" && plugins=yes
1366
1367 cat > $TMPC << EOF
1368
1369 #ifdef __linux__
1370 # define THREAD __thread
1371 #else
1372 # define THREAD
1373 #endif
1374 static THREAD int tls_var;
1375 int main(void) { return tls_var; }
1376 EOF
1377
1378 # Meson currently only handles pie as a boolean for now so if we have
1379 # explicitly disabled PIE we need to extend our cflags because it wont.
1380 if test "$static" = "yes"; then
1381 if test "$pie" != "no" && compile_prog "-Werror -fPIE -DPIE" "-static-pie"; then
1382 CONFIGURE_CFLAGS="-fPIE -DPIE $CONFIGURE_CFLAGS"
1383 pie="yes"
1384 elif test "$pie" = "yes"; then
1385 error_exit "-static-pie not available due to missing toolchain support"
1386 else
1387 pie="no"
1388 QEMU_CFLAGS="-fno-pie $QEMU_CFLAGS"
1389 fi
1390 elif test "$pie" = "no"; then
1391 if compile_prog "-Werror -fno-pie" "-no-pie"; then
1392 CONFIGURE_CFLAGS="-fno-pie $CONFIGURE_CFLAGS"
1393 CONFIGURE_LDFLAGS="-no-pie $CONFIGURE_LDFLAGS"
1394 QEMU_CFLAGS="-fno-pie -no-pie $QEMU_CFLAGS"
1395 fi
1396 elif compile_prog "-Werror -fPIE -DPIE" "-pie"; then
1397 CONFIGURE_CFLAGS="-fPIE -DPIE $CONFIGURE_CFLAGS"
1398 CONFIGURE_LDFLAGS="-pie $CONFIGURE_LDFLAGS"
1399 pie="yes"
1400 elif test "$pie" = "yes"; then
1401 error_exit "PIE not available due to missing toolchain support"
1402 else
1403 echo "Disabling PIE due to missing toolchain support"
1404 pie="no"
1405 fi
1406
1407 ##########################################
1408 # __sync_fetch_and_and requires at least -march=i486. Many toolchains
1409 # use i686 as default anyway, but for those that don't, an explicit
1410 # specification is necessary
1411
1412 if test "$cpu" = "i386"; then
1413 cat > $TMPC << EOF
1414 static int sfaa(int *ptr)
1415 {
1416 return __sync_fetch_and_and(ptr, 0);
1417 }
1418
1419 int main(void)
1420 {
1421 int val = 42;
1422 val = __sync_val_compare_and_swap(&val, 0, 1);
1423 sfaa(&val);
1424 return val;
1425 }
1426 EOF
1427 if ! compile_prog "" "" ; then
1428 QEMU_CFLAGS="-march=i486 $QEMU_CFLAGS"
1429 fi
1430 fi
1431
1432 if test -z "${target_list+xxx}" ; then
1433 default_targets=yes
1434 for target in $default_target_list; do
1435 target_list="$target_list $target"
1436 done
1437 target_list="${target_list# }"
1438 else
1439 default_targets=no
1440 target_list=$(echo "$target_list" | sed -e 's/,/ /g')
1441 for target in $target_list; do
1442 # Check that we recognised the target name; this allows a more
1443 # friendly error message than if we let it fall through.
1444 case " $default_target_list " in
1445 *" $target "*)
1446 ;;
1447 *)
1448 error_exit "Unknown target name '$target'"
1449 ;;
1450 esac
1451 done
1452 fi
1453
1454 # see if system emulation was really requested
1455 case " $target_list " in
1456 *"-softmmu "*) softmmu=yes
1457 ;;
1458 *) softmmu=no
1459 ;;
1460 esac
1461
1462 if test "$tcg" = "auto"; then
1463 if test -z "$target_list"; then
1464 tcg="disabled"
1465 else
1466 tcg="enabled"
1467 fi
1468 fi
1469
1470 if test "$tcg" = "enabled"; then
1471 git_submodules="$git_submodules tests/fp/berkeley-testfloat-3"
1472 git_submodules="$git_submodules tests/fp/berkeley-softfloat-3"
1473 fi
1474
1475 ##########################################
1476 # big/little endian test
1477 cat > $TMPC << EOF
1478 #if defined(__BYTE_ORDER__) && __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
1479 # error LITTLE
1480 #endif
1481 int main(void) { return 0; }
1482 EOF
1483
1484 if ! compile_prog ; then
1485 bigendian="no"
1486 else
1487 cat > $TMPC << EOF
1488 #if defined(__BYTE_ORDER__) && __BYTE_ORDER__ == __ORDER_BIG_ENDIAN__
1489 # error BIG
1490 #endif
1491 int main(void) { return 0; }
1492 EOF
1493
1494 if ! compile_prog ; then
1495 bigendian="yes"
1496 else
1497 echo big/little test failed
1498 exit 1
1499 fi
1500 fi
1501
1502 ##########################################
1503 # pkg-config probe
1504
1505 if ! has "$pkg_config_exe"; then
1506 error_exit "pkg-config binary '$pkg_config_exe' not found"
1507 fi
1508
1509 ##########################################
1510 # glib support probe
1511
1512 # When bumping glib_req_ver, please check also whether we should increase
1513 # the _WIN32_WINNT setting in osdep.h according to the value from glib
1514 glib_req_ver=2.56
1515 glib_modules=gthread-2.0
1516 if test "$modules" = yes; then
1517 glib_modules="$glib_modules gmodule-export-2.0"
1518 elif test "$plugins" = "yes"; then
1519 glib_modules="$glib_modules gmodule-no-export-2.0"
1520 fi
1521
1522 for i in $glib_modules; do
1523 if $pkg_config --atleast-version=$glib_req_ver $i; then
1524 glib_cflags=$($pkg_config --cflags $i)
1525 glib_libs=$($pkg_config --libs $i)
1526 else
1527 error_exit "glib-$glib_req_ver $i is required to compile QEMU"
1528 fi
1529 done
1530
1531 # Check whether glib has gslice, which we have to avoid for correctness.
1532 # TODO: remove this check and the corresponding workaround (qtree) when
1533 # the minimum supported glib is >= $glib_dropped_gslice_version.
1534 glib_dropped_gslice_version=2.75.3
1535 for i in $glib_modules; do
1536 if ! $pkg_config --atleast-version=$glib_dropped_gslice_version $i; then
1537 glib_has_gslice="yes"
1538 break
1539 fi
1540 done
1541
1542 glib_bindir="$($pkg_config --variable=bindir glib-2.0)"
1543 if test -z "$glib_bindir" ; then
1544 glib_bindir="$($pkg_config --variable=prefix glib-2.0)"/bin
1545 fi
1546
1547 # This workaround is required due to a bug in pkg-config file for glib as it
1548 # doesn't define GLIB_STATIC_COMPILATION for pkg-config --static
1549
1550 if test "$static" = yes && test "$mingw32" = yes; then
1551 glib_cflags="-DGLIB_STATIC_COMPILATION $glib_cflags"
1552 fi
1553
1554 # Sanity check that the current size_t matches the
1555 # size that glib thinks it should be. This catches
1556 # problems on multi-arch where people try to build
1557 # 32-bit QEMU while pointing at 64-bit glib headers
1558 cat > $TMPC <<EOF
1559 #include <glib.h>
1560 #include <unistd.h>
1561
1562 #define QEMU_BUILD_BUG_ON(x) \
1563 typedef char qemu_build_bug_on[(x)?-1:1] __attribute__((unused));
1564
1565 int main(void) {
1566 QEMU_BUILD_BUG_ON(sizeof(size_t) != GLIB_SIZEOF_SIZE_T);
1567 return 0;
1568 }
1569 EOF
1570
1571 if ! compile_prog "$glib_cflags" "$glib_libs" ; then
1572 error_exit "sizeof(size_t) doesn't match GLIB_SIZEOF_SIZE_T."\
1573 "You probably need to set PKG_CONFIG_LIBDIR"\
1574 "to point to the right pkg-config files for your"\
1575 "build target"
1576 fi
1577
1578 # Silence clang warnings triggered by glib < 2.57.2
1579 cat > $TMPC << EOF
1580 #include <glib.h>
1581 typedef struct Foo {
1582 int i;
1583 } Foo;
1584 static void foo_free(Foo *f)
1585 {
1586 g_free(f);
1587 }
1588 G_DEFINE_AUTOPTR_CLEANUP_FUNC(Foo, foo_free)
1589 int main(void) { return 0; }
1590 EOF
1591 if ! compile_prog "$glib_cflags -Werror" "$glib_libs" ; then
1592 if cc_has_warning_flag "-Wno-unused-function"; then
1593 glib_cflags="$glib_cflags -Wno-unused-function"
1594 CONFIGURE_CFLAGS="$CONFIGURE_CFLAGS -Wno-unused-function"
1595 fi
1596 fi
1597
1598 ##########################################
1599 # fdt probe
1600
1601 case "$fdt" in
1602 auto | enabled | internal)
1603 # Simpler to always update submodule, even if not needed.
1604 git_submodules="${git_submodules} dtc"
1605 ;;
1606 esac
1607
1608 ##########################################
1609 # check and set a backend for coroutine
1610
1611 # We prefer ucontext, but it's not always possible. The fallback
1612 # is sigcontext. On Windows the only valid backend is the Windows
1613 # specific one.
1614
1615 ucontext_works=no
1616 if test "$darwin" != "yes"; then
1617 cat > $TMPC << EOF
1618 #include <ucontext.h>
1619 #ifdef __stub_makecontext
1620 #error Ignoring glibc stub makecontext which will always fail
1621 #endif
1622 int main(void) { makecontext(0, 0, 0); return 0; }
1623 EOF
1624 if compile_prog "" "" ; then
1625 ucontext_works=yes
1626 fi
1627 fi
1628
1629 if test "$coroutine" = ""; then
1630 if test "$mingw32" = "yes"; then
1631 coroutine=win32
1632 elif test "$ucontext_works" = "yes"; then
1633 coroutine=ucontext
1634 else
1635 coroutine=sigaltstack
1636 fi
1637 else
1638 case $coroutine in
1639 windows)
1640 if test "$mingw32" != "yes"; then
1641 error_exit "'windows' coroutine backend only valid for Windows"
1642 fi
1643 # Unfortunately the user visible backend name doesn't match the
1644 # coroutine-*.c filename for this case, so we have to adjust it here.
1645 coroutine=win32
1646 ;;
1647 ucontext)
1648 if test "$ucontext_works" != "yes"; then
1649 error_exit "'ucontext' backend requested but makecontext not available"
1650 fi
1651 ;;
1652 sigaltstack)
1653 if test "$mingw32" = "yes"; then
1654 error_exit "only the 'windows' coroutine backend is valid for Windows"
1655 fi
1656 ;;
1657 *)
1658 error_exit "unknown coroutine backend $coroutine"
1659 ;;
1660 esac
1661 fi
1662
1663 ##################################################
1664 # SafeStack
1665
1666
1667 if test "$safe_stack" = "yes"; then
1668 cat > $TMPC << EOF
1669 int main(void)
1670 {
1671 #if ! __has_feature(safe_stack)
1672 #error SafeStack Disabled
1673 #endif
1674 return 0;
1675 }
1676 EOF
1677 flag="-fsanitize=safe-stack"
1678 # Check that safe-stack is supported and enabled.
1679 if compile_prog "-Werror $flag" "$flag"; then
1680 # Flag needed both at compilation and at linking
1681 QEMU_CFLAGS="$QEMU_CFLAGS $flag"
1682 QEMU_LDFLAGS="$QEMU_LDFLAGS $flag"
1683 else
1684 error_exit "SafeStack not supported by your compiler"
1685 fi
1686 if test "$coroutine" != "ucontext"; then
1687 error_exit "SafeStack is only supported by the coroutine backend ucontext"
1688 fi
1689 else
1690 cat > $TMPC << EOF
1691 int main(void)
1692 {
1693 #if defined(__has_feature)
1694 #if __has_feature(safe_stack)
1695 #error SafeStack Enabled
1696 #endif
1697 #endif
1698 return 0;
1699 }
1700 EOF
1701 if test "$safe_stack" = "no"; then
1702 # Make sure that safe-stack is disabled
1703 if ! compile_prog "-Werror" ""; then
1704 # SafeStack was already enabled, try to explicitly remove the feature
1705 flag="-fno-sanitize=safe-stack"
1706 if ! compile_prog "-Werror $flag" "$flag"; then
1707 error_exit "Configure cannot disable SafeStack"
1708 fi
1709 QEMU_CFLAGS="$QEMU_CFLAGS $flag"
1710 QEMU_LDFLAGS="$QEMU_LDFLAGS $flag"
1711 fi
1712 else # "$safe_stack" = ""
1713 # Set safe_stack to yes or no based on pre-existing flags
1714 if compile_prog "-Werror" ""; then
1715 safe_stack="no"
1716 else
1717 safe_stack="yes"
1718 if test "$coroutine" != "ucontext"; then
1719 error_exit "SafeStack is only supported by the coroutine backend ucontext"
1720 fi
1721 fi
1722 fi
1723 fi
1724
1725 ########################################
1726 # check if ccache is interfering with
1727 # semantic analysis of macros
1728
1729 unset CCACHE_CPP2
1730 ccache_cpp2=no
1731 cat > $TMPC << EOF
1732 static const int Z = 1;
1733 #define fn() ({ Z; })
1734 #define TAUT(X) ((X) == Z)
1735 #define PAREN(X, Y) (X == Y)
1736 #define ID(X) (X)
1737 int main(void)
1738 {
1739 int x = 0, y = 0;
1740 x = ID(x);
1741 x = fn();
1742 fn();
1743 if (PAREN(x, y)) return 0;
1744 if (TAUT(Z)) return 0;
1745 return 0;
1746 }
1747 EOF
1748
1749 if ! compile_object "-Werror"; then
1750 ccache_cpp2=yes
1751 fi
1752
1753 #################################################
1754 # clang does not support glibc + FORTIFY_SOURCE.
1755
1756 if test "$fortify_source" != "no"; then
1757 if echo | $cc -dM -E - | grep __clang__ > /dev/null 2>&1 ; then
1758 fortify_source="no";
1759 elif test -n "$cxx" && has $cxx &&
1760 echo | $cxx -dM -E - | grep __clang__ >/dev/null 2>&1 ; then
1761 fortify_source="no";
1762 else
1763 fortify_source="yes"
1764 fi
1765 fi
1766
1767 ##########################################
1768 # checks for sanitizers
1769
1770 have_asan=no
1771 have_ubsan=no
1772 have_asan_iface_h=no
1773 have_asan_iface_fiber=no
1774
1775 if test "$sanitizers" = "yes" ; then
1776 write_c_skeleton
1777 if compile_prog "$CPU_CFLAGS -Werror -fsanitize=address" ""; then
1778 have_asan=yes
1779 fi
1780
1781 # we could use a simple skeleton for flags checks, but this also
1782 # detect the static linking issue of ubsan, see also:
1783 # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=84285
1784 cat > $TMPC << EOF
1785 int main(int argc, char **argv)
1786 {
1787 return argc + 1;
1788 }
1789 EOF
1790 if compile_prog "$CPU_CFLAGS -Werror -fsanitize=undefined" ""; then
1791 have_ubsan=yes
1792 fi
1793
1794 if check_include "sanitizer/asan_interface.h" ; then
1795 have_asan_iface_h=yes
1796 fi
1797
1798 cat > $TMPC << EOF
1799 #include <sanitizer/asan_interface.h>
1800 int main(void) {
1801 __sanitizer_start_switch_fiber(0, 0, 0);
1802 return 0;
1803 }
1804 EOF
1805 if compile_prog "$CPU_CFLAGS -Werror -fsanitize=address" "" ; then
1806 have_asan_iface_fiber=yes
1807 fi
1808 fi
1809
1810 # Thread sanitizer is, for now, much noisier than the other sanitizers;
1811 # keep it separate until that is not the case.
1812 if test "$tsan" = "yes" && test "$sanitizers" = "yes"; then
1813 error_exit "TSAN is not supported with other sanitiziers."
1814 fi
1815 have_tsan=no
1816 have_tsan_iface_fiber=no
1817 if test "$tsan" = "yes" ; then
1818 write_c_skeleton
1819 if compile_prog "$CPU_CFLAGS -Werror -fsanitize=thread" "" ; then
1820 have_tsan=yes
1821 fi
1822 cat > $TMPC << EOF
1823 #include <sanitizer/tsan_interface.h>
1824 int main(void) {
1825 __tsan_create_fiber(0);
1826 return 0;
1827 }
1828 EOF
1829 if compile_prog "$CPU_CFLAGS -Werror -fsanitize=thread" "" ; then
1830 have_tsan_iface_fiber=yes
1831 fi
1832 fi
1833
1834 ##########################################
1835 # functions to probe cross compilers
1836
1837 container="no"
1838 runc=""
1839 if test $use_containers = "yes" && (has "docker" || has "podman"); then
1840 case $($python "$source_path"/tests/docker/docker.py probe) in
1841 *docker) container=docker ;;
1842 podman) container=podman ;;
1843 no) container=no ;;
1844 esac
1845 if test "$container" != "no"; then
1846 docker_py="$python $source_path/tests/docker/docker.py --engine $container"
1847 runc=$($python "$source_path"/tests/docker/docker.py probe)
1848 fi
1849 fi
1850
1851 # cross compilers defaults, can be overridden with --cross-cc-ARCH
1852 : ${cross_prefix_aarch64="aarch64-linux-gnu-"}
1853 : ${cross_prefix_aarch64_be="$cross_prefix_aarch64"}
1854 : ${cross_prefix_alpha="alpha-linux-gnu-"}
1855 : ${cross_prefix_arm="arm-linux-gnueabihf-"}
1856 : ${cross_prefix_armeb="$cross_prefix_arm"}
1857 : ${cross_prefix_hexagon="hexagon-unknown-linux-musl-"}
1858 : ${cross_prefix_loongarch64="loongarch64-unknown-linux-gnu-"}
1859 : ${cross_prefix_hppa="hppa-linux-gnu-"}
1860 : ${cross_prefix_i386="i686-linux-gnu-"}
1861 : ${cross_prefix_m68k="m68k-linux-gnu-"}
1862 : ${cross_prefix_microblaze="microblaze-linux-musl-"}
1863 : ${cross_prefix_mips64el="mips64el-linux-gnuabi64-"}
1864 : ${cross_prefix_mips64="mips64-linux-gnuabi64-"}
1865 : ${cross_prefix_mipsel="mipsel-linux-gnu-"}
1866 : ${cross_prefix_mips="mips-linux-gnu-"}
1867 : ${cross_prefix_nios2="nios2-linux-gnu-"}
1868 : ${cross_prefix_ppc="powerpc-linux-gnu-"}
1869 : ${cross_prefix_ppc64="powerpc64-linux-gnu-"}
1870 : ${cross_prefix_ppc64le="$cross_prefix_ppc64"}
1871 : ${cross_prefix_riscv64="riscv64-linux-gnu-"}
1872 : ${cross_prefix_s390x="s390x-linux-gnu-"}
1873 : ${cross_prefix_sh4="sh4-linux-gnu-"}
1874 : ${cross_prefix_sparc64="sparc64-linux-gnu-"}
1875 : ${cross_prefix_sparc="$cross_prefix_sparc64"}
1876 : ${cross_prefix_x86_64="x86_64-linux-gnu-"}
1877
1878 : ${cross_cc_aarch64_be="$cross_cc_aarch64"}
1879 : ${cross_cc_cflags_aarch64_be="-mbig-endian"}
1880 : ${cross_cc_armeb="$cross_cc_arm"}
1881 : ${cross_cc_cflags_armeb="-mbig-endian"}
1882 : ${cross_cc_hexagon="hexagon-unknown-linux-musl-clang"}
1883 : ${cross_cc_cflags_hexagon="-mv67 -O2 -static"}
1884 : ${cross_cc_cflags_i386="-m32"}
1885 : ${cross_cc_cflags_ppc="-m32 -mbig-endian"}
1886 : ${cross_cc_cflags_ppc64="-m64 -mbig-endian"}
1887 : ${cross_cc_ppc64le="$cross_cc_ppc64"}
1888 : ${cross_cc_cflags_ppc64le="-m64 -mlittle-endian"}
1889 : ${cross_cc_cflags_sparc64="-m64 -mcpu=ultrasparc"}
1890 : ${cross_cc_sparc="$cross_cc_sparc64"}
1891 : ${cross_cc_cflags_sparc="-m32 -mcpu=supersparc"}
1892 : ${cross_cc_cflags_x86_64="-m64"}
1893
1894 compute_target_variable() {
1895 eval "$2="
1896 if eval test -n "\"\${cross_prefix_$1}\""; then
1897 if eval has "\"\${cross_prefix_$1}\$3\""; then
1898 eval "$2=\"\${cross_prefix_$1}\$3\""
1899 fi
1900 fi
1901 }
1902
1903 have_target() {
1904 for i; do
1905 case " $target_list " in
1906 *" $i "*) return 0;;
1907 *) ;;
1908 esac
1909 done
1910 return 1
1911 }
1912
1913 # probe_target_compiler TARGET
1914 #
1915 # Look for a compiler for the given target, either native or cross.
1916 # Set variables target_* if a compiler is found, and container_cross_*
1917 # if a Docker-based cross-compiler image is known for the target.
1918 # Set got_cross_cc to yes/no depending on whether a non-container-based
1919 # compiler was found.
1920 #
1921 # If TARGET is a user-mode emulation target, also set build_static to
1922 # "y" if static linking is possible.
1923 #
1924 probe_target_compiler() {
1925 # reset all output variables
1926 got_cross_cc=no
1927 container_image=
1928 container_hosts=
1929 container_cross_cc=
1930 container_cross_ar=
1931 container_cross_as=
1932 container_cross_ld=
1933 container_cross_nm=
1934 container_cross_objcopy=
1935 container_cross_ranlib=
1936 container_cross_strip=
1937
1938 # We shall skip configuring the target compiler if the user didn't
1939 # bother enabling an appropriate guest. This avoids building
1940 # extraneous firmware images and tests.
1941 if test "${target_list#*$1}" = "$1"; then
1942 return 1
1943 fi
1944
1945 target_arch=${1%%-*}
1946 case $target_arch in
1947 aarch64) container_hosts="x86_64 aarch64" ;;
1948 alpha) container_hosts=x86_64 ;;
1949 arm) container_hosts="x86_64 aarch64" ;;
1950 cris) container_hosts=x86_64 ;;
1951 hexagon) container_hosts=x86_64 ;;
1952 hppa) container_hosts=x86_64 ;;
1953 i386) container_hosts=x86_64 ;;
1954 loongarch64) container_hosts=x86_64 ;;
1955 m68k) container_hosts=x86_64 ;;
1956 microblaze) container_hosts=x86_64 ;;
1957 mips64el) container_hosts=x86_64 ;;
1958 mips64) container_hosts=x86_64 ;;
1959 mipsel) container_hosts=x86_64 ;;
1960 mips) container_hosts=x86_64 ;;
1961 nios2) container_hosts=x86_64 ;;
1962 ppc) container_hosts=x86_64 ;;
1963 ppc64|ppc64le) container_hosts=x86_64 ;;
1964 riscv64) container_hosts=x86_64 ;;
1965 s390x) container_hosts=x86_64 ;;
1966 sh4) container_hosts=x86_64 ;;
1967 sparc64) container_hosts=x86_64 ;;
1968 tricore) container_hosts=x86_64 ;;
1969 x86_64) container_hosts="aarch64 ppc64el x86_64" ;;
1970 xtensa*) container_hosts=x86_64 ;;
1971 esac
1972
1973 for host in $container_hosts; do
1974 test "$container" != no || continue
1975 test "$host" = "$cpu" || continue
1976 case $target_arch in
1977 aarch64)
1978 # We don't have any bigendian build tools so we only use this for AArch64
1979 container_image=debian-arm64-cross
1980 container_cross_prefix=aarch64-linux-gnu-
1981 container_cross_cc=${container_cross_prefix}gcc-10
1982 ;;
1983 alpha)
1984 container_image=debian-alpha-cross
1985 container_cross_prefix=alpha-linux-gnu-
1986 ;;
1987 arm)
1988 # We don't have any bigendian build tools so we only use this for ARM
1989 container_image=debian-armhf-cross
1990 container_cross_prefix=arm-linux-gnueabihf-
1991 ;;
1992 cris)
1993 container_image=fedora-cris-cross
1994 container_cross_prefix=cris-linux-gnu-
1995 ;;
1996 hexagon)
1997 container_image=debian-hexagon-cross
1998 container_cross_prefix=hexagon-unknown-linux-musl-
1999 container_cross_cc=${container_cross_prefix}clang
2000 ;;
2001 hppa)
2002 container_image=debian-hppa-cross
2003 container_cross_prefix=hppa-linux-gnu-
2004 ;;
2005 i386)
2006 container_image=fedora-i386-cross
2007 container_cross_prefix=
2008 ;;
2009 loongarch64)
2010 container_image=debian-loongarch-cross
2011 container_cross_prefix=loongarch64-unknown-linux-gnu-
2012 ;;
2013 m68k)
2014 container_image=debian-m68k-cross
2015 container_cross_prefix=m68k-linux-gnu-
2016 ;;
2017 microblaze)
2018 container_image=debian-microblaze-cross
2019 container_cross_prefix=microblaze-linux-musl-
2020 ;;
2021 mips64el)
2022 container_image=debian-mips64el-cross
2023 container_cross_prefix=mips64el-linux-gnuabi64-
2024 ;;
2025 mips64)
2026 container_image=debian-mips64-cross
2027 container_cross_prefix=mips64-linux-gnuabi64-
2028 ;;
2029 mipsel)
2030 container_image=debian-mipsel-cross
2031 container_cross_prefix=mipsel-linux-gnu-
2032 ;;
2033 mips)
2034 container_image=debian-mips-cross
2035 container_cross_prefix=mips-linux-gnu-
2036 ;;
2037 nios2)
2038 container_image=debian-nios2-cross
2039 container_cross_prefix=nios2-linux-gnu-
2040 ;;
2041 ppc)
2042 container_image=debian-powerpc-test-cross
2043 container_cross_prefix=powerpc-linux-gnu-
2044 container_cross_cc=${container_cross_prefix}gcc-10
2045 ;;
2046 ppc64|ppc64le)
2047 container_image=debian-powerpc-test-cross
2048 container_cross_prefix=powerpc${target_arch#ppc}-linux-gnu-
2049 container_cross_cc=${container_cross_prefix}gcc-10
2050 ;;
2051 riscv64)
2052 container_image=debian-riscv64-test-cross
2053 container_cross_prefix=riscv64-linux-gnu-
2054 ;;
2055 s390x)
2056 container_image=debian-s390x-cross
2057 container_cross_prefix=s390x-linux-gnu-
2058 ;;
2059 sh4)
2060 container_image=debian-sh4-cross
2061 container_cross_prefix=sh4-linux-gnu-
2062 ;;
2063 sparc64)
2064 container_image=debian-sparc64-cross
2065 container_cross_prefix=sparc64-linux-gnu-
2066 ;;
2067 tricore)
2068 container_image=debian-tricore-cross
2069 container_cross_prefix=tricore-
2070 container_cross_as=tricore-as
2071 container_cross_ld=tricore-ld
2072 break
2073 ;;
2074 x86_64)
2075 container_image=debian-amd64-cross
2076 container_cross_prefix=x86_64-linux-gnu-
2077 ;;
2078 xtensa*)
2079 container_hosts=x86_64
2080 container_image=debian-xtensa-cross
2081
2082 # default to the dc232b cpu
2083 container_cross_prefix=/opt/2020.07/xtensa-dc232b-elf/bin/xtensa-dc232b-elf-
2084 ;;
2085 esac
2086 : ${container_cross_cc:=${container_cross_prefix}gcc}
2087 : ${container_cross_ar:=${container_cross_prefix}ar}
2088 : ${container_cross_as:=${container_cross_prefix}as}
2089 : ${container_cross_ld:=${container_cross_prefix}ld}
2090 : ${container_cross_nm:=${container_cross_prefix}nm}
2091 : ${container_cross_objcopy:=${container_cross_prefix}objcopy}
2092 : ${container_cross_ranlib:=${container_cross_prefix}ranlib}
2093 : ${container_cross_strip:=${container_cross_prefix}strip}
2094 done
2095
2096 try=cross
2097 case "$target_arch:$cpu" in
2098 aarch64_be:aarch64 | \
2099 armeb:arm | \
2100 i386:x86_64 | \
2101 mips*:mips64 | \
2102 ppc*:ppc64 | \
2103 sparc:sparc64 | \
2104 "$cpu:$cpu")
2105 try='native cross' ;;
2106 esac
2107 eval "target_cflags=\${cross_cc_cflags_$target_arch}"
2108 for thistry in $try; do
2109 case $thistry in
2110 native)
2111 target_cc=$cc
2112 target_ccas=$ccas
2113 target_ar=$ar
2114 target_as=$as
2115 target_ld=$ld
2116 target_nm=$nm
2117 target_objcopy=$objcopy
2118 target_ranlib=$ranlib
2119 target_strip=$strip
2120 ;;
2121 cross)
2122 target_cc=
2123 if eval test -n "\"\${cross_cc_$target_arch}\""; then
2124 if eval has "\"\${cross_cc_$target_arch}\""; then
2125 eval "target_cc=\"\${cross_cc_$target_arch}\""
2126 fi
2127 else
2128 compute_target_variable $target_arch target_cc gcc
2129 fi
2130 target_ccas=$target_cc
2131 compute_target_variable $target_arch target_ar ar
2132 compute_target_variable $target_arch target_as as
2133 compute_target_variable $target_arch target_ld ld
2134 compute_target_variable $target_arch target_nm nm
2135 compute_target_variable $target_arch target_objcopy objcopy
2136 compute_target_variable $target_arch target_ranlib ranlib
2137 compute_target_variable $target_arch target_strip strip
2138 ;;
2139 esac
2140
2141 if test -n "$target_cc"; then
2142 case $target_arch in
2143 i386|x86_64)
2144 if $target_cc --version | grep -qi "clang"; then
2145 continue
2146 fi
2147 ;;
2148 esac
2149 elif test -n "$target_as" && test -n "$target_ld"; then
2150 # Special handling for assembler only targets
2151 case $target in
2152 tricore-softmmu)
2153 build_static=
2154 got_cross_cc=yes
2155 break
2156 ;;
2157 *)
2158 continue
2159 ;;
2160 esac
2161 else
2162 continue
2163 fi
2164
2165 write_c_skeleton
2166 case $1 in
2167 *-softmmu)
2168 if do_compiler "$target_cc" $target_cflags -o $TMPO -c $TMPC &&
2169 do_compiler "$target_cc" $target_cflags -r -nostdlib -o "${TMPDIR1}/${TMPB}2.o" "$TMPO" -lgcc; then
2170 got_cross_cc=yes
2171 break
2172 fi
2173 ;;
2174 *)
2175 if do_compiler "$target_cc" $target_cflags -o $TMPE $TMPC -static ; then
2176 build_static=y
2177 got_cross_cc=yes
2178 break
2179 fi
2180 if do_compiler "$target_cc" $target_cflags -o $TMPE $TMPC ; then
2181 build_static=
2182 got_cross_cc=yes
2183 break
2184 fi
2185 ;;
2186 esac
2187 done
2188 if test $got_cross_cc != yes; then
2189 build_static=
2190 target_cc=
2191 target_ccas=
2192 target_ar=
2193 target_as=
2194 target_ld=
2195 target_nm=
2196 target_objcopy=
2197 target_ranlib=
2198 target_strip=
2199 fi
2200 test -n "$target_cc"
2201 }
2202
2203 write_target_makefile() {
2204 echo "EXTRA_CFLAGS=$target_cflags"
2205 if test -z "$target_cc" && test -z "$target_as"; then
2206 test -z "$container_image" && error_exit "Internal error: could not find cross compiler for $1?"
2207 echo "$1: docker-image-$container_image" >> Makefile.prereqs
2208 if test -n "$container_cross_cc"; then
2209 echo "CC=$docker_py cc --cc $container_cross_cc -i qemu/$container_image -s $source_path --"
2210 echo "CCAS=$docker_py cc --cc $container_cross_cc -i qemu/$container_image -s $source_path --"
2211 fi
2212 echo "AR=$docker_py cc --cc $container_cross_ar -i qemu/$container_image -s $source_path --"
2213 echo "AS=$docker_py cc --cc $container_cross_as -i qemu/$container_image -s $source_path --"
2214 echo "LD=$docker_py cc --cc $container_cross_ld -i qemu/$container_image -s $source_path --"
2215 echo "NM=$docker_py cc --cc $container_cross_nm -i qemu/$container_image -s $source_path --"
2216 echo "OBJCOPY=$docker_py cc --cc $container_cross_objcopy -i qemu/$container_image -s $source_path --"
2217 echo "RANLIB=$docker_py cc --cc $container_cross_ranlib -i qemu/$container_image -s $source_path --"
2218 echo "STRIP=$docker_py cc --cc $container_cross_strip -i qemu/$container_image -s $source_path --"
2219 else
2220 if test -n "$target_cc"; then
2221 echo "CC=$target_cc"
2222 echo "CCAS=$target_ccas"
2223 fi
2224 if test -n "$target_ar"; then
2225 echo "AR=$target_ar"
2226 fi
2227 if test -n "$target_as"; then
2228 echo "AS=$target_as"
2229 fi
2230 if test -n "$target_ld"; then
2231 echo "LD=$target_ld"
2232 fi
2233 if test -n "$target_nm"; then
2234 echo "NM=$target_nm"
2235 fi
2236 if test -n "$target_objcopy"; then
2237 echo "OBJCOPY=$target_objcopy"
2238 fi
2239 if test -n "$target_ranlib"; then
2240 echo "RANLIB=$target_ranlib"
2241 fi
2242 if test -n "$target_strip"; then
2243 echo "STRIP=$target_strip"
2244 fi
2245 fi
2246 }
2247
2248 ##########################################
2249 # check for vfio_user_server
2250
2251 case "$vfio_user_server" in
2252 enabled )
2253 if test "$git_submodules_action" != "ignore"; then
2254 git_submodules="${git_submodules} subprojects/libvfio-user"
2255 fi
2256 ;;
2257 esac
2258
2259 ##########################################
2260 # End of CC checks
2261 # After here, no more $cc or $ld runs
2262
2263 write_c_skeleton
2264
2265 if test "$fortify_source" = "yes" ; then
2266 QEMU_CFLAGS="-U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2 $QEMU_CFLAGS"
2267 fi
2268
2269 if test "$have_asan" = "yes"; then
2270 QEMU_CFLAGS="-fsanitize=address $QEMU_CFLAGS"
2271 QEMU_LDFLAGS="-fsanitize=address $QEMU_LDFLAGS"
2272 if test "$have_asan_iface_h" = "no" ; then
2273 echo "ASAN build enabled, but ASAN header missing." \
2274 "Without code annotation, the report may be inferior."
2275 elif test "$have_asan_iface_fiber" = "no" ; then
2276 echo "ASAN build enabled, but ASAN header is too old." \
2277 "Without code annotation, the report may be inferior."
2278 fi
2279 fi
2280 if test "$have_tsan" = "yes" ; then
2281 if test "$have_tsan_iface_fiber" = "yes" ; then
2282 QEMU_CFLAGS="-fsanitize=thread $QEMU_CFLAGS"
2283 QEMU_LDFLAGS="-fsanitize=thread $QEMU_LDFLAGS"
2284 else
2285 error_exit "Cannot enable TSAN due to missing fiber annotation interface."
2286 fi
2287 elif test "$tsan" = "yes" ; then
2288 error_exit "Cannot enable TSAN due to missing sanitize thread interface."
2289 fi
2290 if test "$have_ubsan" = "yes"; then
2291 QEMU_CFLAGS="-fsanitize=undefined $QEMU_CFLAGS"
2292 QEMU_LDFLAGS="-fsanitize=undefined $QEMU_LDFLAGS"
2293 fi
2294
2295 #######################################
2296 # cross-compiled firmware targets
2297
2298 # Set up build tree symlinks that point back into the source tree
2299 # (these can be both files and directories).
2300 # Caution: avoid adding files or directories here using wildcards. This
2301 # will result in problems later if a new file matching the wildcard is
2302 # added to the source tree -- nothing will cause configure to be rerun
2303 # so the build tree will be missing the link back to the new file, and
2304 # tests might fail. Prefer to keep the relevant files in their own
2305 # directory and symlink the directory instead.
2306 LINKS="Makefile"
2307 LINKS="$LINKS docs/config"
2308 LINKS="$LINKS pc-bios/optionrom/Makefile"
2309 LINKS="$LINKS pc-bios/s390-ccw/Makefile"
2310 LINKS="$LINKS pc-bios/vof/Makefile"
2311 LINKS="$LINKS .gdbinit scripts" # scripts needed by relative path in .gdbinit
2312 LINKS="$LINKS tests/avocado tests/data"
2313 LINKS="$LINKS tests/qemu-iotests/check"
2314 LINKS="$LINKS python"
2315 LINKS="$LINKS contrib/plugins/Makefile "
2316 for f in $LINKS ; do
2317 if [ -e "$source_path/$f" ]; then
2318 mkdir -p "$(dirname ./"$f")"
2319 symlink "$source_path/$f" "$f"
2320 fi
2321 done
2322
2323 echo "# Automatically generated by configure - do not modify" > Makefile.prereqs
2324
2325 # Mac OS X ships with a broken assembler
2326 roms=
2327 if have_target i386-softmmu x86_64-softmmu && \
2328 test "$targetos" != "darwin" && test "$targetos" != "sunos" && \
2329 test "$targetos" != "haiku" && \
2330 probe_target_compiler i386-softmmu; then
2331 roms="pc-bios/optionrom"
2332 config_mak=pc-bios/optionrom/config.mak
2333 echo "# Automatically generated by configure - do not modify" > $config_mak
2334 echo "TOPSRC_DIR=$source_path" >> $config_mak
2335 write_target_makefile >> $config_mak
2336 fi
2337
2338 if have_target ppc-softmmu ppc64-softmmu && \
2339 probe_target_compiler ppc-softmmu; then
2340 roms="$roms pc-bios/vof"
2341 config_mak=pc-bios/vof/config.mak
2342 echo "# Automatically generated by configure - do not modify" > $config_mak
2343 echo "SRC_DIR=$source_path/pc-bios/vof" >> $config_mak
2344 write_target_makefile >> $config_mak
2345 fi
2346
2347 # Only build s390-ccw bios if the compiler has -march=z900 or -march=z10
2348 # (which is the lowest architecture level that Clang supports)
2349 if have_target s390x-softmmu && probe_target_compiler s390x-softmmu; then
2350 write_c_skeleton
2351 do_compiler "$target_cc" $target_cc_cflags -march=z900 -o $TMPO -c $TMPC
2352 has_z900=$?
2353 if [ $has_z900 = 0 ] || do_compiler "$target_cc" $target_cc_cflags -march=z10 -msoft-float -Werror -o $TMPO -c $TMPC; then
2354 if [ $has_z900 != 0 ]; then
2355 echo "WARNING: Your compiler does not support the z900!"
2356 echo " The s390-ccw bios will only work with guest CPUs >= z10."
2357 fi
2358 roms="$roms pc-bios/s390-ccw"
2359 config_mak=pc-bios/s390-ccw/config-host.mak
2360 echo "# Automatically generated by configure - do not modify" > $config_mak
2361 echo "SRC_PATH=$source_path/pc-bios/s390-ccw" >> $config_mak
2362 write_target_makefile >> $config_mak
2363 # SLOF is required for building the s390-ccw firmware on s390x,
2364 # since it is using the libnet code from SLOF for network booting.
2365 git_submodules="${git_submodules} roms/SLOF"
2366 fi
2367 fi
2368
2369 #######################################
2370 # generate config-host.mak
2371
2372 if ! (GIT="$git" "$source_path/scripts/git-submodule.sh" "$git_submodules_action" "$git_submodules"); then
2373 exit 1
2374 fi
2375
2376 config_host_mak="config-host.mak"
2377
2378 echo "# Automatically generated by configure - do not modify" > $config_host_mak
2379 echo >> $config_host_mak
2380
2381 echo all: >> $config_host_mak
2382 echo "GIT=$git" >> $config_host_mak
2383 echo "GIT_SUBMODULES=$git_submodules" >> $config_host_mak
2384 echo "GIT_SUBMODULES_ACTION=$git_submodules_action" >> $config_host_mak
2385
2386 if test "$debug_tcg" = "yes" ; then
2387 echo "CONFIG_DEBUG_TCG=y" >> $config_host_mak
2388 fi
2389 if test "$mingw32" = "yes" ; then
2390 echo "CONFIG_WIN32=y" >> $config_host_mak
2391 echo "QEMU_GA_MANUFACTURER=${QEMU_GA_MANUFACTURER-QEMU}" >> $config_host_mak
2392 echo "QEMU_GA_DISTRO=${QEMU_GA_DISTRO-Linux}" >> $config_host_mak
2393 echo "QEMU_GA_VERSION=${QEMU_GA_VERSION-$(cat "$source_path"/VERSION)}" >> $config_host_mak
2394 else
2395 echo "CONFIG_POSIX=y" >> $config_host_mak
2396 fi
2397
2398 if test "$linux" = "yes" ; then
2399 echo "CONFIG_LINUX=y" >> $config_host_mak
2400 fi
2401
2402 if test "$darwin" = "yes" ; then
2403 echo "CONFIG_DARWIN=y" >> $config_host_mak
2404 fi
2405
2406 if test "$solaris" = "yes" ; then
2407 echo "CONFIG_SOLARIS=y" >> $config_host_mak
2408 fi
2409 if test "$static" = "yes" ; then
2410 echo "CONFIG_STATIC=y" >> $config_host_mak
2411 fi
2412 echo "SRC_PATH=$source_path" >> $config_host_mak
2413 echo "TARGET_DIRS=$target_list" >> $config_host_mak
2414 if test "$modules" = "yes"; then
2415 echo "CONFIG_MODULES=y" >> $config_host_mak
2416 fi
2417
2418 # XXX: suppress that
2419 if [ "$bsd" = "yes" ] ; then
2420 echo "CONFIG_BSD=y" >> $config_host_mak
2421 fi
2422
2423 echo "CONFIG_COROUTINE_BACKEND=$coroutine" >> $config_host_mak
2424
2425 if test "$have_asan_iface_fiber" = "yes" ; then
2426 echo "CONFIG_ASAN_IFACE_FIBER=y" >> $config_host_mak
2427 fi
2428
2429 if test "$have_tsan" = "yes" && test "$have_tsan_iface_fiber" = "yes" ; then
2430 echo "CONFIG_TSAN=y" >> $config_host_mak
2431 fi
2432
2433 if test "$plugins" = "yes" ; then
2434 echo "CONFIG_PLUGIN=y" >> $config_host_mak
2435 fi
2436
2437 if test -n "$gdb_bin"; then
2438 gdb_version=$($gdb_bin --version | head -n 1)
2439 if version_ge ${gdb_version##* } 9.1; then
2440 echo "HAVE_GDB_BIN=$gdb_bin" >> $config_host_mak
2441 gdb_arches=$("$source_path/scripts/probe-gdb-support.py" $gdb_bin)
2442 else
2443 gdb_bin=""
2444 fi
2445 fi
2446
2447 if test "$container" != no; then
2448 echo "ENGINE=$container" >> $config_host_mak
2449 echo "RUNC=$runc" >> $config_host_mak
2450 fi
2451 echo "ROMS=$roms" >> $config_host_mak
2452 echo "MAKE=$make" >> $config_host_mak
2453 echo "PYTHON=$python" >> $config_host_mak
2454 echo "GENISOIMAGE=$genisoimage" >> $config_host_mak
2455 echo "MESON=$meson" >> $config_host_mak
2456 echo "NINJA=$ninja" >> $config_host_mak
2457 echo "CC=$cc" >> $config_host_mak
2458 echo "QEMU_CFLAGS=$QEMU_CFLAGS" >> $config_host_mak
2459 echo "QEMU_OBJCFLAGS=$QEMU_OBJCFLAGS" >> $config_host_mak
2460 echo "GLIB_CFLAGS=$glib_cflags" >> $config_host_mak
2461 echo "GLIB_LIBS=$glib_libs" >> $config_host_mak
2462 echo "GLIB_BINDIR=$glib_bindir" >> $config_host_mak
2463 echo "GLIB_VERSION=$($pkg_config --modversion glib-2.0)" >> $config_host_mak
2464 if test "$glib_has_gslice" = "yes" ; then
2465 echo "HAVE_GLIB_WITH_SLICE_ALLOCATOR=y" >> $config_host_mak
2466 fi
2467 echo "QEMU_LDFLAGS=$QEMU_LDFLAGS" >> $config_host_mak
2468 echo "EXESUF=$EXESUF" >> $config_host_mak
2469
2470 # use included Linux headers
2471 if test "$linux" = "yes" ; then
2472 mkdir -p linux-headers
2473 case "$cpu" in
2474 i386|x86_64)
2475 linux_arch=x86
2476 ;;
2477 ppc|ppc64)
2478 linux_arch=powerpc
2479 ;;
2480 s390x)
2481 linux_arch=s390
2482 ;;
2483 aarch64)
2484 linux_arch=arm64
2485 ;;
2486 loongarch*)
2487 linux_arch=loongarch
2488 ;;
2489 mips64)
2490 linux_arch=mips
2491 ;;
2492 *)
2493 # For most CPUs the kernel architecture name and QEMU CPU name match.
2494 linux_arch="$cpu"
2495 ;;
2496 esac
2497 # For non-KVM architectures we will not have asm headers
2498 if [ -e "$source_path/linux-headers/asm-$linux_arch" ]; then
2499 symlink "$source_path/linux-headers/asm-$linux_arch" linux-headers/asm
2500 fi
2501 fi
2502
2503 for target in $target_list; do
2504 target_dir="$target"
2505 target_name=$(echo $target | cut -d '-' -f 1)$EXESUF
2506 mkdir -p "$target_dir"
2507 case $target in
2508 *-user) symlink "../qemu-$target_name" "$target_dir/qemu-$target_name" ;;
2509 *) symlink "../qemu-system-$target_name" "$target_dir/qemu-system-$target_name" ;;
2510 esac
2511 done
2512
2513 if test "$default_targets" = "yes"; then
2514 echo "CONFIG_DEFAULT_TARGETS=y" >> $config_host_mak
2515 fi
2516
2517 if test "$ccache_cpp2" = "yes"; then
2518 echo "export CCACHE_CPP2=y" >> $config_host_mak
2519 fi
2520
2521 if test "$safe_stack" = "yes"; then
2522 echo "CONFIG_SAFESTACK=y" >> $config_host_mak
2523 fi
2524
2525 # tests/tcg configuration
2526 (config_host_mak=tests/tcg/config-host.mak
2527 mkdir -p tests/tcg
2528 echo "# Automatically generated by configure - do not modify" > $config_host_mak
2529 echo "SRC_PATH=$source_path" >> $config_host_mak
2530 echo "HOST_CC=$host_cc" >> $config_host_mak
2531
2532 # versioned checked in the main config_host.mak above
2533 if test -n "$gdb_bin"; then
2534 echo "HAVE_GDB_BIN=$gdb_bin" >> $config_host_mak
2535 fi
2536 if test "$plugins" = "yes" ; then
2537 echo "CONFIG_PLUGIN=y" >> $config_host_mak
2538 fi
2539
2540 tcg_tests_targets=
2541 for target in $target_list; do
2542 arch=${target%%-*}
2543
2544 case $target in
2545 xtensa*-linux-user)
2546 # the toolchain is not complete with headers, only build softmmu tests
2547 continue
2548 ;;
2549 *-softmmu)
2550 test -f "$source_path/tests/tcg/$arch/Makefile.softmmu-target" || continue
2551 qemu="qemu-system-$arch"
2552 ;;
2553 *-linux-user|*-bsd-user)
2554 qemu="qemu-$arch"
2555 ;;
2556 esac
2557
2558 if probe_target_compiler $target || test -n "$container_image"; then
2559 test -n "$container_image" && build_static=y
2560 mkdir -p "tests/tcg/$target"
2561 config_target_mak=tests/tcg/$target/config-target.mak
2562 ln -sf "$source_path/tests/tcg/Makefile.target" "tests/tcg/$target/Makefile"
2563 echo "# Automatically generated by configure - do not modify" > "$config_target_mak"
2564 echo "TARGET_NAME=$arch" >> "$config_target_mak"
2565 echo "TARGET=$target" >> "$config_target_mak"
2566 write_target_makefile "build-tcg-tests-$target" >> "$config_target_mak"
2567 echo "BUILD_STATIC=$build_static" >> "$config_target_mak"
2568 echo "QEMU=$PWD/$qemu" >> "$config_target_mak"
2569
2570 # will GDB work with these binaries?
2571 if test "${gdb_arches#*$arch}" != "$gdb_arches"; then
2572 echo "HOST_GDB_SUPPORTS_ARCH=y" >> "$config_target_mak"
2573 fi
2574
2575 echo "run-tcg-tests-$target: $qemu\$(EXESUF)" >> Makefile.prereqs
2576 tcg_tests_targets="$tcg_tests_targets $target"
2577 fi
2578 done
2579
2580 if test "$tcg" = "enabled"; then
2581 echo "TCG_TESTS_TARGETS=$tcg_tests_targets" >> config-host.mak
2582 fi
2583 )
2584
2585 if test "$skip_meson" = no; then
2586 cross="config-meson.cross.new"
2587 meson_quote() {
2588 test $# = 0 && return
2589 echo "'$(echo $* | sed "s/ /','/g")'"
2590 }
2591
2592 echo "# Automatically generated by configure - do not modify" > $cross
2593 echo "[properties]" >> $cross
2594
2595 # unroll any custom device configs
2596 for a in $device_archs; do
2597 eval "c=\$devices_${a}"
2598 echo "${a}-softmmu = '$c'" >> $cross
2599 done
2600
2601 echo "[built-in options]" >> $cross
2602 echo "c_args = [$(meson_quote $CFLAGS $EXTRA_CFLAGS)]" >> $cross
2603 echo "cpp_args = [$(meson_quote $CXXFLAGS $EXTRA_CXXFLAGS)]" >> $cross
2604 test -n "$objcc" && echo "objc_args = [$(meson_quote $OBJCFLAGS $EXTRA_OBJCFLAGS)]" >> $cross
2605 echo "c_link_args = [$(meson_quote $CFLAGS $LDFLAGS $EXTRA_CFLAGS $EXTRA_LDFLAGS)]" >> $cross
2606 echo "cpp_link_args = [$(meson_quote $CXXFLAGS $LDFLAGS $EXTRA_CXXFLAGS $EXTRA_LDFLAGS)]" >> $cross
2607 echo "[binaries]" >> $cross
2608 echo "c = [$(meson_quote $cc $CPU_CFLAGS)]" >> $cross
2609 test -n "$cxx" && echo "cpp = [$(meson_quote $cxx $CPU_CFLAGS)]" >> $cross
2610 test -n "$objcc" && echo "objc = [$(meson_quote $objcc $CPU_CFLAGS)]" >> $cross
2611 echo "ar = [$(meson_quote $ar)]" >> $cross
2612 echo "nm = [$(meson_quote $nm)]" >> $cross
2613 echo "pkgconfig = [$(meson_quote $pkg_config_exe)]" >> $cross
2614 echo "ranlib = [$(meson_quote $ranlib)]" >> $cross
2615 if has $sdl2_config; then
2616 echo "sdl2-config = [$(meson_quote $sdl2_config)]" >> $cross
2617 fi
2618 echo "strip = [$(meson_quote $strip)]" >> $cross
2619 echo "widl = [$(meson_quote $widl)]" >> $cross
2620 echo "windres = [$(meson_quote $windres)]" >> $cross
2621 echo "windmc = [$(meson_quote $windmc)]" >> $cross
2622 if test "$cross_compile" = "yes"; then
2623 cross_arg="--cross-file config-meson.cross"
2624 echo "[host_machine]" >> $cross
2625 echo "system = '$targetos'" >> $cross
2626 case "$cpu" in
2627 i386)
2628 echo "cpu_family = 'x86'" >> $cross
2629 ;;
2630 *)
2631 echo "cpu_family = '$cpu'" >> $cross
2632 ;;
2633 esac
2634 echo "cpu = '$cpu'" >> $cross
2635 if test "$bigendian" = "yes" ; then
2636 echo "endian = 'big'" >> $cross
2637 else
2638 echo "endian = 'little'" >> $cross
2639 fi
2640 else
2641 cross_arg="--native-file config-meson.cross"
2642 fi
2643 mv $cross config-meson.cross
2644
2645 rm -rf meson-private meson-info meson-logs
2646
2647 # Prevent meson from automatically downloading wrapped subprojects when missing.
2648 # You can use 'meson subprojects download' before running configure.
2649 meson_option_add "--wrap-mode=nodownload"
2650
2651 # Built-in options
2652 test "$bindir" != "bin" && meson_option_add "-Dbindir=$bindir"
2653 test "$default_feature" = no && meson_option_add -Dauto_features=disabled
2654 test "$pie" = no && meson_option_add -Db_pie=false
2655 test "$werror" = yes && meson_option_add -Dwerror=true
2656
2657 # QEMU options
2658 test "$cfi" != false && meson_option_add "-Dcfi=$cfi"
2659 test "$docs" != auto && meson_option_add "-Ddocs=$docs"
2660 test "$fdt" != auto && meson_option_add "-Dfdt=$fdt"
2661 test -n "${LIB_FUZZING_ENGINE+xxx}" && meson_option_add "-Dfuzzing_engine=$LIB_FUZZING_ENGINE"
2662 test "$qemu_suffix" != qemu && meson_option_add "-Dqemu_suffix=$qemu_suffix"
2663 test "$smbd" != '' && meson_option_add "-Dsmbd=$smbd"
2664 test "$tcg" != enabled && meson_option_add "-Dtcg=$tcg"
2665 test "$vfio_user_server" != auto && meson_option_add "-Dvfio_user_server=$vfio_user_server"
2666 run_meson() {
2667 NINJA=$ninja $meson setup --prefix "$prefix" "$@" $cross_arg "$PWD" "$source_path"
2668 }
2669 eval run_meson $meson_options
2670 if test "$?" -ne 0 ; then
2671 error_exit "meson setup failed"
2672 fi
2673 fi
2674
2675 # Save the configure command line for later reuse.
2676 cat <<EOD >config.status
2677 #!/bin/sh
2678 # Generated by configure.
2679 # Run this file to recreate the current configuration.
2680 # Compiler output produced by configure, useful for debugging
2681 # configure, is in config.log if it exists.
2682 EOD
2683
2684 preserve_env() {
2685 envname=$1
2686
2687 eval envval=\$$envname
2688
2689 if test -n "$envval"
2690 then
2691 echo "$envname='$envval'" >> config.status
2692 echo "export $envname" >> config.status
2693 else
2694 echo "unset $envname" >> config.status
2695 fi
2696 }
2697
2698 # Preserve various env variables that influence what
2699 # features/build target configure will detect
2700 preserve_env AR
2701 preserve_env AS
2702 preserve_env CC
2703 preserve_env CFLAGS
2704 preserve_env CXX
2705 preserve_env CXXFLAGS
2706 preserve_env LD
2707 preserve_env LDFLAGS
2708 preserve_env LD_LIBRARY_PATH
2709 preserve_env MAKE
2710 preserve_env NM
2711 preserve_env OBJCFLAGS
2712 preserve_env OBJCOPY
2713 preserve_env PATH
2714 preserve_env PKG_CONFIG
2715 preserve_env PKG_CONFIG_LIBDIR
2716 preserve_env PKG_CONFIG_PATH
2717 preserve_env PYTHON
2718 preserve_env QEMU_GA_MANUFACTURER
2719 preserve_env QEMU_GA_DISTRO
2720 preserve_env QEMU_GA_VERSION
2721 preserve_env SDL2_CONFIG
2722 preserve_env SMBD
2723 preserve_env STRIP
2724 preserve_env WIDL
2725 preserve_env WINDRES
2726 preserve_env WINDMC
2727
2728 printf "exec" >>config.status
2729 for i in "$0" "$@"; do
2730 test "$i" = --skip-meson || printf " %s" "$(quote_sh "$i")" >>config.status
2731 done
2732 echo ' "$@"' >>config.status
2733 chmod +x config.status
2734
2735 rm -r "$TMPDIR1"